package com.yestae.order.aftersales.service.impl;

package ..deTemp.1730484861094;

import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Lists;
import com.yestae.c.utils.MemberUtils;
import com.yestae.coin.api.ICoinDubboService;
import com.yestae.coin.api.dto.CoinChangeVo;
import com.yestae.coin.api.dto.CoinDto;
import com.yestae.coin.api.dto.ItemJson;
import com.yestae.coin.api.enums.BizTypeEnum;
import com.yestae.coin.api.enums.ProductEnum;
import com.yestae.coin.api.enums.SourceEnum;
import com.yestae.coin.api.result.CoinResult;
import com.yestae.coin.api.vo.CoinVo;
import com.yestae.common.annotation.TeaTransactional;
import com.yestae.common.api.MemberVo;
import com.yestae.common.enums.BooleanEnum;
import com.yestae.common.utils.Assert;
import com.yestae.common.utils.BeanUtil;
import com.yestae.common.utils.DateUtil;
import com.yestae.common.utils.JsonUtil;
import com.yestae.common.utils.ToolUtil;
import com.yestae.framework.common.domain.AppResult;
import com.yestae.framework.common.domain.DataApp;
import com.yestae.framework.common.domain.DataResult;
import com.yestae.framework.common.domain.PageAppResult;
import com.yestae.framework.common.domain.PageResult;
import com.yestae.framework.common.domain.TeaBaseEntity;
import com.yestae.framework.common.enums.ErrorCode;
import com.yestae.framework.common.exception.SystemException;
import com.yestae.framework.common.utils.BizUserUtil;
import com.yestae.framework.common.utils.StringUtils;
import com.yestae.framework.id.client.SnowflakeIdWorker;
import com.yestae.framework.rabbit.model.QueueMessage;
import com.yestae.framework.rabbit.sender.MessageSender;
import com.yestae.framework.redis.annotation.ExclusiveLock;
import com.yestae.framework.redis.client.JedisClient;
import com.yestae.framework.redis.lock.DistributedLock;
import com.yestae.framework.redis.lock.RedisLock;
import com.yestae.framework.utils.collections.CollectionUtil;
import com.yestae.goods.api.OrderResult;
import com.yestae.mall.aftersales.manager.dto.LogisticsDto;
import com.yestae.mall.aftersales.manager.enums.OrderAftersalesRedInvoiceFlagEnum;
import com.yestae.mall.aftersales.manager.feign.LogisticsServiceFeign;
import com.yestae.mall.aftersales.manager.vo.LogisticsVO;
import com.yestae.mall.operate.system.setup.vo.OrderSetupUnDeliveryProductVO;
import com.yestae.order.aftersales.client.AtomClient;
import com.yestae.order.aftersales.constants.Constants;
import com.yestae.order.aftersales.context.AftersaleContext;
import com.yestae.order.aftersales.dto.AftersalesResponse;
import com.yestae.order.aftersales.dto.CoinHandlerAmount;
import com.yestae.order.aftersales.dto.OrderAddressDto;
import com.yestae.order.aftersales.dto.OrderCanAftersalesDto;
import com.yestae.order.aftersales.dto.SampleOrderInfoDto;
import com.yestae.order.aftersales.entity.MaterialCertificate;
import com.yestae.order.aftersales.entity.MaterialCertificateMedia;
import com.yestae.order.aftersales.entity.Order;
import com.yestae.order.aftersales.entity.OrderAddress;
import com.yestae.order.aftersales.entity.OrderAftersales;
import com.yestae.order.aftersales.entity.OrderAftersalesAddress;
import com.yestae.order.aftersales.entity.OrderAftersalesGoods;
import com.yestae.order.aftersales.entity.OrderApprovalProcess;
import com.yestae.order.aftersales.entity.OrderGoods;
import com.yestae.order.aftersales.entity.OrderGoodsTagDescInfo;
import com.yestae.order.aftersales.entity.OrderInvoice;
import com.yestae.order.aftersales.entity.OrderLogger;
import com.yestae.order.aftersales.entity.OrderRefund;
import com.yestae.order.aftersales.enums.CertificateSourceEnum;
import com.yestae.order.aftersales.enums.CertificateTypeEnum;
import com.yestae.order.aftersales.enums.GoodsTagEnum;
import com.yestae.order.aftersales.enums.OrderAfterSalesProcessEnum;
import com.yestae.order.aftersales.enums.OrderAfterSalesStatusEnum;
import com.yestae.order.aftersales.enums.OrderAftersalesDeliveryOperatorEnum;
import com.yestae.order.aftersales.enums.OrderAftersalesErrorCodeEnum;
import com.yestae.order.aftersales.enums.OrderAftersalesTypeEnum;
import com.yestae.order.aftersales.enums.OrderApprovalApprovalStatusEnum;
import com.yestae.order.aftersales.enums.OrderApprovalProcessBusinessTypeEnum;
import com.yestae.order.aftersales.enums.OrderBusinessTypeEnum;
import com.yestae.order.aftersales.enums.OrderDeliveryStatusEnum;
import com.yestae.order.aftersales.enums.OrderFinishStateEnum;
import com.yestae.order.aftersales.enums.OrderGoodsErrorCodeEnum;
import com.yestae.order.aftersales.enums.OrderInvoiceStatusEnum;
import com.yestae.order.aftersales.enums.OrderLoggerEventTypeEnum;
import com.yestae.order.aftersales.enums.OrderLoggerTypeEnum;
import com.yestae.order.aftersales.enums.OrderReceiveStateEnum;
import com.yestae.order.aftersales.enums.OrderSourceEnum;
import com.yestae.order.aftersales.enums.OrderStatusEnum;
import com.yestae.order.aftersales.service.AftersalesService;
import com.yestae.order.aftersales.service.AutoRefundService;
import com.yestae.order.aftersales.service.MaterialCertificateMediaService;
import com.yestae.order.aftersales.service.MaterialCertificateService;
import com.yestae.order.aftersales.service.OrderAddressService;
import com.yestae.order.aftersales.service.OrderAftersalesAddressService;
import com.yestae.order.aftersales.service.OrderAftersalesGoodsService;
import com.yestae.order.aftersales.service.OrderAftersalesService;
import com.yestae.order.aftersales.service.OrderApprovalProcessService;
import com.yestae.order.aftersales.service.OrderGoodsService;
import com.yestae.order.aftersales.service.OrderInvoiceService;
import com.yestae.order.aftersales.service.OrderService;
import com.yestae.order.aftersales.service.ThirdService;
import com.yestae.order.aftersales.utils.AftersaleSysBaseSetupUtil;
import com.yestae.order.aftersales.utils.AftersalesMessageSendUtil;
import com.yestae.order.aftersales.utils.ApportionUtils;
import com.yestae.order.aftersales.utils.OrderAddressModifyUtil;
import com.yestae.order.aftersales.utils.YestaeCoinUtils;
import com.yestae.order.aftersales.validator.AftersalesValidator;
import com.yestae.order.aftersales.vo.AftersalesActionMessageVO;
import com.yestae.order.aftersales.vo.AftersalesApportionInfo;
import com.yestae.order.aftersales.vo.AftersalesCancelRequest;
import com.yestae.order.aftersales.vo.AftersalesGoodsApportionInfo;
import com.yestae.order.aftersales.vo.AftersalesGoodsGetRequest;
import com.yestae.order.aftersales.vo.AftersalesGoodsRequest;
import com.yestae.order.aftersales.vo.AftersalesMediaRequest;
import com.yestae.order.aftersales.vo.AftersalesRequest;
import com.yestae.order.aftersales.vo.AftersalesStatusMessageVo;
import com.yestae.order.aftersales.vo.AftersalesTimeOutMessageVo;
import com.yestae.order.aftersales.vo.ApprovalAftersalesVo;
import com.yestae.order.aftersales.vo.AtomResult;
import com.yestae.order.aftersales.vo.GrowthMessageVO;
import com.yestae.order.aftersales.vo.OrderAddressModifyRequest;
import com.yestae.order.aftersales.vo.OrderAddressVO;
import com.yestae.order.aftersales.vo.OrderAfterSalesStateChangeVo;
import com.yestae.order.aftersales.vo.OrderAftersalesAddressVO;
import com.yestae.order.aftersales.vo.OrderAftersalesGoodsTag;
import com.yestae.order.aftersales.vo.OrderAftersalesGoodsVO;
import com.yestae.order.aftersales.vo.OrderAftersalesVO;
import com.yestae.order.aftersales.vo.OrderApprovalProcessVO;
import com.yestae.order.aftersales.vo.OrderInvoiceVO;
import com.yestae.order.aftersales.vo.OrderMqInfo;
import com.yestae.order.api.IMarkBizDubboServcie;
import com.yestae.order.api.IOrderDubboService;
import com.yestae.order.api.ISopOrderDubboService;
import com.yestae.order.api.OrderAddressVo;
import com.yestae.order.api.UnDeliveryAftersalesLockVo;
import com.yestae.order.api.enums.MarkEnum;
import com.yestae.order.api.vo.openapi.MarkBizRequestVO;
import com.yestae.user.center.dubbo.entity.UserAddressDubbo;
import com.yestae.user.center.dubbo.entity.UserResult;
import com.yestae.user.center.dubbo.service.IUserCenterShipAddressService;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.time.Instant;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;
import java.util.concurrent.atomic.AtomicReference;
import java.util.stream.Collectors;
import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import org.apache.commons.collections.CollectionUtils;
import org.apache.dubbo.config.annotation.DubboReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

@Service
public class AftersalesServiceImpl implements AftersalesService {
  private static final Logger logger = LoggerFactory.getLogger(com.yestae.order.aftersales.service.impl.AftersalesServiceImpl.class);
  
  private static final String AFTER_SALES_SETUP = "after_sales_setup";
  
  private final ApplicationContext applicationContext;
  
  private final List<AftersalesValidator> aftersalesValidatorList;
  
  private AftersalesService aftersalesService;
  
  @Resource
  private OrderAftersalesService orderAftersalesService;
  
  @Resource
  private OrderAftersalesGoodsService orderAftersalesGoodsService;
  
  @Resource
  private OrderGoodsService orderGoodsService;
  
  @Resource
  private MessageSender messageSender;
  
  @Resource
  private OrderAftersalesAddressService orderAftersalesAddressService;
  
  @Resource
  private AftersalesMessageSendUtil aftersalesMessageSendUtil;
  
  @Resource
  private OrderService orderService;
  
  @DubboReference
  private IOrderDubboService orderDubboService;
  
  @DubboReference
  private ICoinDubboService coinDubboService;
  
  @DubboReference
  private IMarkBizDubboServcie markBizDubboServcie;
  
  @Resource
  private JedisClient jedisClient;
  
  @Resource
  private MaterialCertificateService materialCertificateService;
  
  @Resource
  private MaterialCertificateMediaService materialCertificateMediaService;
  
  @DubboReference
  private IUserCenterShipAddressService userCenterShipAddressService;
  
  @DubboReference
  private ISopOrderDubboService iSopOrderDubboService;
  
  @Resource
  private LogisticsServiceFeign logisticsServiceFeign;
  
  @Resource
  private AtomClient atomclient;
  
  @Resource
  private OrderApprovalProcessService approvalProcessService;
  
  @Resource
  private AftersaleSysBaseSetupUtil aftersaleSysBaseSetupUtil;
  
  @Resource
  private OrderAddressService orderAddressService;
  
  @Resource
  private AutoRefundService autoRefundService;
  
  @Resource
  private DistributedLock distributedLock;
  
  @Resource
  private ThirdService thirdService;
  
  @Resource
  private OrderInvoiceService orderInvoiceService;
  
  public AftersalesServiceImpl(ApplicationContext applicationContext, List<AftersalesValidator> aftersalesValidatorList) {
    this.applicationContext = applicationContext;
    this.aftersalesValidatorList = aftersalesValidatorList;
  }
  
  @PostConstruct
  public void init() {
    this.aftersalesService = (AftersalesService)this.applicationContext.getBean(AftersalesService.class);
  }
  
  @TeaTransactional
  public OrderCanAftersalesDto queryOrderGoodsCanAfterSales(AftersalesGoodsGetRequest aftersalesGoodsGetRequest, boolean isSpecial) {
    String aftersalesId = aftersalesGoodsGetRequest.getAfterSalesId();
    Long memberUserId = MemberUtils.getMemberUserId();
    Assert.isNotBlank(aftersalesId, "原售后单Id不能为空");
    try (AftersaleContext context = AftersaleContext.createContext()) {
      context.setMemberId(String.valueOf(memberUserId));
      context.setOrderAftersalesId(aftersalesId);
      OrderAftersales orderAftersales = context.getOrderAftersales();
      context.setOrderId(orderAftersales.getOrderId());
      Order order = context.getOrder();
      Long aftersaleVersion = order.getAftersaleVersion();
      BigDecimal deliveryCost = orderAftersales.getDeliveryCost();
      boolean result = false;
      Integer applyState = orderAftersales.getApplyState();
      if (OrderAfterSalesStatusEnum.REJECTED.getValue() == applyState.intValue()) {
        result = this.orderAftersalesService.doAutoClose(((OrderAftersalesVO)(new OrderAftersalesVO()).setId(aftersalesId)).setMemberNo(context.getMemberNo()));
      } else if (OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue() == applyState.intValue()) {
        logger.info("待审核重新发起售后");
        OrderAftersales aftersales = cancel((new AftersalesCancelRequest()).setId(aftersalesId).setStartChannel(aftersalesGoodsGetRequest.getStartChannel()));
        result = Objects.nonNull(aftersales);
      } 
      Assert.isTrue(result, "获取可售后商品列表失败");
      OrderCanAftersalesDto orderCanAftersalesDto = this.orderAftersalesService.queryOrderGoodsCanAfterSales(aftersalesGoodsGetRequest, isSpecial);
      TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
      orderCanAftersalesDto.setAftersaleVersion(aftersaleVersion);
      if (Objects.nonNull(orderCanAftersalesDto.getCanRefundCost())) {
        orderCanAftersalesDto.setCanRefundCost(orderCanAftersalesDto.getCanRefundCost().add(deliveryCost));
      } else {
        orderCanAftersalesDto.setCanRefundCost(deliveryCost);
      } 
      OrderAftersalesAddressVO orderAftersalesAddressVO = (OrderAftersalesAddressVO)(new OrderAftersalesAddressVO()).setAftersalesId((String)orderAftersales.getId()).setDeleteFlag(Integer.valueOf(BooleanEnum.NO.getValue()));
      List<OrderAftersalesAddress> addressList = this.orderAftersalesAddressService.getList(orderAftersalesAddressVO);
      if (CollectionUtils.isNotEmpty(addressList)) {
        OrderAftersalesAddress orderAftersalesAddress = addressList.get(0);
        orderCanAftersalesDto.setOriginOrderAddress((OrderAddressDto)BeanUtil.copyProperties(orderAftersalesAddress, OrderAddressDto.class));
      } 
      return orderCanAftersalesDto;
    } 
  }
  
  @TeaTransactional
  public AftersalesResponse apply(AftersalesRequest request) {
    Assert.isNotNull(request, "请求参数不合法");
    List<AftersalesRequest> requests = request.getRequests();
    if (CollectionUtil.isEmpty(requests)) {
      Assert.isNotEmpty(request.getGoodsList(), "售后商品列表不能为空");
      requests = new ArrayList<>(1);
      requests.add(request);
    } else {
      for (AftersalesRequest aftersalesRequest : requests) {
        Assert.isNotEmpty(aftersalesRequest.getGoodsList(), "售后商品列表不能为空");
        aftersalesRequest.setApplyType(request.getApplyType())
          .setApplyReason(request.getApplyReason())
          .setApplyReasonName(request.getApplyReasonName())
          .setApplyGoodsState(request.getApplyGoodsState())
          .setMemberId(request.getMemberId())
          .setMemberNo(request.getMemberNo())
          .setOrderId(request.getOrderId())
          .setOrderNo(request.getOrderNo())
          .setOldAftersaleId(request.getOldAftersaleId())
          .setOutAftersaleId(request.getOutAftersaleId())
          .setOutAftersaleState(request.getOutAftersaleState())
          .setContent(Objects.isNull(aftersalesRequest.getContent()) ? request.getContent() : aftersalesRequest.getContent())
          .setAftersaleVersion(Objects.isNull(aftersalesRequest.getAftersaleVersion()) ? request.getAftersaleVersion() : aftersalesRequest.getAftersaleVersion())
          .setOrderAftersalesAddress(request.getOrderAftersalesAddress())
          .setAddressId(request.getAddressId())
          .setMediaList(request.getMediaList())
          .setStartChannel(request.getStartChannel());
      } 
    } 
    try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
      aftersaleContext.setMemberId(((AftersalesRequest)requests.get(0)).getMemberId())
        .setMemberNo(((AftersalesRequest)requests.get(0)).getMemberNo())
        .setOrderId(((AftersalesRequest)requests.get(0)).getOrderId())
        .setCurrentRequest(requests.get(0));
      requests = splitAndSortRequests(requests);
      if (StringUtils.isNotEmpty(((AftersalesRequest)requests.get(0)).getOldAftersaleId())) {
        closeAftersalesBeforeApply(((AftersalesRequest)requests.get(0)).getOldAftersaleId(), aftersaleContext.getMemberNo(), ((AftersalesRequest)requests.get(0)).getStartChannel(), ((AftersalesRequest)requests.get(0)).getAftersaleVersion());
        aftersaleContext.setOrderGoodsList(null);
        aftersaleContext.setOrder(null);
      } 
      if (CollectionUtil.isNotEmpty(this.aftersalesValidatorList))
        for (AftersalesRequest requestItem : requests) {
          aftersaleContext.setCurrentRequest(requestItem);
          for (AftersalesValidator validator : this.aftersalesValidatorList) {
            String message = validator.beforeSubmit();
            if (StringUtils.isNotBlank(message))
              throw new SystemException(ErrorCode.PARAM_ERROR.getCode(), message); 
          } 
        }  
      return this.aftersalesService.doApply(requests);
    } 
  }
  
  public void closeAftersalesBeforeApply(String aftersaleId, Long memberNo, Integer startChannel, Long aftersaleVersion) {
    if (StringUtils.isNotEmpty(aftersaleId)) {
      OrderAftersales oldOrderAftersales = this.orderAftersalesService.getByPrimaryKey(((OrderAftersales)(new OrderAftersales()).setId(aftersaleId)).setMemberNo(memberNo));
      Assert.isNotNull(oldOrderAftersales, "老的售后单未找到");
      Order order = this.orderService.getByPrimaryKey(((Order)(new Order()).setId(oldOrderAftersales.getOrderId())).setMemberNo(memberNo));
      Assert.isNotNull(oldOrderAftersales, "订单未找到");
      if (!Objects.equals(aftersaleVersion, order.getAftersaleVersion()) || 
        !Arrays.<Integer>asList(new Integer[] { Integer.valueOf(OrderAfterSalesStatusEnum.REJECTED.getValue()), Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue()) }).contains(oldOrderAftersales.getApplyState()))
        throw new SystemException(OrderAftersalesErrorCodeEnum.AFTERSALES_VERSION_CHANGED); 
      Assert.isTrue((Objects.isNull(oldOrderAftersales.getReApplyEndTime()) || oldOrderAftersales.getReApplyEndTime().longValue() > Instant.now().toEpochMilli()), "售后单重新发起时间已超时");
      if (Objects.equals(oldOrderAftersales.getApplyState(), Integer.valueOf(OrderAfterSalesStatusEnum.REJECTED.getValue()))) {
        this.orderAftersalesService.doAutoClose(((OrderAftersalesVO)(new OrderAftersalesVO()).setId(aftersaleId)).setMemberNo(memberNo));
      } else if (Objects.equals(oldOrderAftersales.getApplyState(), Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue()))) {
        cancel((new AftersalesCancelRequest()).setId(aftersaleId).setStartChannel(startChannel));
      } 
    } 
  }
  
  private List<AftersalesRequest> splitAndSortRequests(List<AftersalesRequest> requests) {
    AftersaleContext aftersaleContext = AftersaleContext.getInstance();
    Order order = aftersaleContext.getOrder();
    Integer applyType = ((AftersalesRequest)requests.get(0)).getApplyType();
    if (!aftersaleContext.isSpecialAfterSale().booleanValue() && (applyType
      .equals(Integer.valueOf(OrderAftersalesTypeEnum.RETURN_GOODS_AND_REFUND.getValue())) || (applyType
      .equals(Integer.valueOf(OrderAftersalesTypeEnum.ONLY_REFUND.getValue())) && StringUtils.equals(order.getOrderState(), OrderStatusEnum.UN_DELIVER.getName())))) {
      Assert.isTrue((requests.size() == 1), "请求不合法");
      List<OrderGoods> orderGoodsList = aftersaleContext.getOrderGoodsList();
      AftersalesRequest aftersalesRequest = requests.get(0);
      AtomicReference<OrderGoods> orderGoodsReference = new AtomicReference<>();
      AtomicReference<AftersalesGoodsRequest> goodsRequestReference = new AtomicReference<>();
      aftersalesRequest.getGoodsList()
        .forEach(goodsItem -> {
            Assert.isNotBlank(goodsItem.getOrderGoodsId(), "参数不合法");
            Optional<OrderGoods> goodsOptional = orderGoodsList.stream().filter(()).findFirst();
            Assert.isTrue(goodsOptional.isPresent(), "未找到要退货的商品信息");
            orderGoodsReference.set(goodsOptional.get());
            goodsItem.setGoodsTag(((OrderGoods)goodsOptional.get()).getGoodsTag());
            goodsItem.setGoodsTagDesc(((OrderGoods)goodsOptional.get()).getGoodsTagDesc());
            if (goodsItem.getGoodsTag() != null && goodsItem.getGoodsTag().equals(Integer.valueOf(GoodsTagEnum.BUY_AT_WILL.getValue())))
              goodsRequestReference.set(goodsItem); 
          });
      AftersalesGoodsRequest aftersalesGoodsRequest = goodsRequestReference.get();
      if (aftersalesGoodsRequest == null) {
        Optional<OrderGoods> goodsOptional = orderGoodsList.stream().filter(orderGoods -> (orderGoods.getGoodsTag() != null && orderGoods.getGoodsTag().equals(Integer.valueOf(GoodsTagEnum.BUY_AT_WILL.getValue())) && orderGoods.getAftersalesGoodsNums().floatValue() - orderGoods.getRefundsOnlyAppliedNum().floatValue() > 0.0F)).findFirst();
        if (goodsOptional.isPresent()) {
          OrderGoodsTagDescInfo tagDescInfo = (OrderGoodsTagDescInfo)JsonUtil.toObject(((OrderGoods)goodsOptional.get()).getGoodsTagDesc(), OrderGoodsTagDescInfo.class);
          List<OrderGoods> orderGoodsCopy = BeanUtil.copyList(orderGoodsList, OrderGoods.class);
          BigDecimal money = orderGoodsCopy.stream().filter(orderGoods -> (orderGoods.getGoodsTag() == null || !orderGoods.getGoodsTag().equals(Integer.valueOf(GoodsTagEnum.BUY_AT_WILL.getValue())))).map(orderGoods -> {
                Optional<AftersalesGoodsRequest> goodsRequestOptional = aftersalesRequest.getGoodsList().stream().filter(()).findFirst();
                int returnCount = goodsRequestOptional.isPresent() ? ((AftersalesGoodsRequest)goodsRequestOptional.get()).getGoodsNum().intValue() : 0;
                int leftCount = orderGoods.getAftersalesGoodsNums().intValue() - returnCount;
                return (leftCount < 1) ? BigDecimal.ZERO : orderGoods.getSalePrice().multiply(new BigDecimal(leftCount));
              }).reduce(BigDecimal.ZERO, BigDecimal::add);
          if (money.compareTo(tagDescInfo.getRuleAmount()) < 0) {
            OrderGoods orderGoods = goodsOptional.get();
            Map<String, String> orderReturnWarehouse = aftersaleContext.getOrderReturnWarehouse();
            String orderGoodsId = (String)orderGoods.getId();
            Boolean existSameWarehouse = Boolean.valueOf(true);
            if (applyType.equals(Integer.valueOf(OrderAftersalesTypeEnum.RETURN_GOODS_AND_REFUND.getValue()))) {
              String buyAtWillReturnWarehouse = orderReturnWarehouse.get(orderGoodsId);
              existSameWarehouse = Boolean.valueOf(aftersalesRequest.getGoodsList().stream().anyMatch(a -> {
                      String warehouseId = (String)orderReturnWarehouse.get(a.getOrderGoodsId());
                      return StringUtils.equals(buyAtWillReturnWarehouse, warehouseId);
                    }));
            } 
            AftersalesGoodsRequest goodsRequest = (new AftersalesGoodsRequest()).setOrderGoodsId(orderGoodsId).setGoodsNum(Integer.valueOf(orderGoods.getGoodsNums().intValue())).setGoodsTag(Integer.valueOf(GoodsTagEnum.BUY_AT_WILL.getValue()));
            if (existSameWarehouse.booleanValue()) {
              aftersalesRequest.getGoodsList().add(goodsRequest);
              aftersalesRequest.setPayAmount(aftersalesRequest.getPayAmount().add(((OrderGoods)goodsOptional.get()).getPayAmount()))
                .setRefundCoinAmount(aftersalesRequest.getRefundCoinAmount().add(((OrderGoods)goodsOptional.get()).getPointPmtNum()));
            } else {
              AftersalesRequest aftersalesRequestCopy = (AftersalesRequest)BeanUtil.copyProperties(aftersalesRequest, AftersalesRequest.class);
              aftersalesRequestCopy.setOldAftersaleId(null);
              List<AftersalesGoodsRequest> aftersalesGoodsRequests = new ArrayList<>(1);
              aftersalesGoodsRequests.add(goodsRequest);
              aftersalesRequestCopy.setGoodsList(aftersalesGoodsRequests)
                .setPayAmount(orderGoods.getPayAmount())
                .setRefundCoinAmount(orderGoods.getPointPmtNum())
                .setRecoverIssuedCoinAmount(BigDecimal.ZERO)
                .setDeliveryCost(BigDecimal.ZERO);
              requests.add(aftersalesRequestCopy);
            } 
          } 
        } 
      } else {
        if (aftersalesRequest.getGoodsList().size() == 1 || !applyType.equals(Integer.valueOf(OrderAftersalesTypeEnum.RETURN_GOODS_AND_REFUND.getValue())))
          return requests; 
        Map<String, String> orderReturnWarehouse = aftersaleContext.getOrderReturnWarehouse();
        String orderGoodsId = aftersalesGoodsRequest.getOrderGoodsId();
        String buyAtWillReturnWarehouse = orderReturnWarehouse.get(orderGoodsId);
        List<AftersalesGoodsRequest> goodsList = aftersalesRequest.getGoodsList();
        Iterator<AftersalesGoodsRequest> iterator = goodsList.iterator();
        while (iterator.hasNext()) {
          AftersalesGoodsRequest goodsRequest = iterator.next();
          if (!((String)orderReturnWarehouse.get(goodsRequest.getOrderGoodsId())).equals(buyAtWillReturnWarehouse)) {
            AftersalesRequest aftersalesRequestCopy = (AftersalesRequest)BeanUtil.copyProperties(aftersalesRequest, AftersalesRequest.class);
            goodsList.remove(aftersalesGoodsRequest);
            OrderGoods orderGoods = orderGoodsReference.get();
            aftersalesRequest.setPayAmount(aftersalesRequest.getPayAmount().subtract(orderGoods.getPayAmount()))
              .setRefundCoinAmount(aftersalesRequest.getRefundCoinAmount().subtract(orderGoods.getPointPmtNum()));
            List<AftersalesGoodsRequest> aftersalesGoodsRequests = new ArrayList<>(1);
            aftersalesGoodsRequests.add(aftersalesGoodsRequest);
            aftersalesRequestCopy.setGoodsList(aftersalesGoodsRequests)
              .setPayAmount(orderGoods.getPayAmount())
              .setRefundCoinAmount(orderGoods.getPointPmtNum())
              .setRecoverIssuedCoinAmount(BigDecimal.ZERO)
              .setDeliveryCost(BigDecimal.ZERO);
            requests.add(aftersalesRequestCopy);
            break;
          } 
        } 
      } 
    } 
    requests.sort(Comparator.comparing(item -> Long.valueOf(item.getGoodsList().stream().filter(()).count())));
    return requests;
  }
  
  @TeaTransactional
  @ExclusiveLock(key = "order.aftersales.do", spel = "#p0.id")
  public OrderAftersales cancel(AftersalesCancelRequest request) {
    OrderAftersales result;
    try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
      aftersaleContext.setOrderAftersales(null);
      aftersaleContext.setOrderAftersalesId(request.getId());
      OrderAftersales orderAftersales = aftersaleContext.getOrderAftersales();
      Assert.isNotNull(orderAftersales, "售后单不能为空");
      if (logger.isInfoEnabled())
        logger.info("取消售后,售后单信息={}", JsonUtil.toJson(orderAftersales)); 
      boolean managerCancel = Arrays.stream(AftersaleContext.specialStartChannels).anyMatch(item -> request.getStartChannel().equals(Integer.valueOf(item)));
      cancelCheck(managerCancel, orderAftersales);
      List<OrderAftersalesGoods> goodsList = aftersaleContext.getOrderAftersalesGoodsList();
      Assert.isNotNull(orderAftersales, "售后单不能为空");
      aftersaleContext.setMemberId(orderAftersales.getMemberId());
      aftersaleContext.setMemberNo(orderAftersales.getMemberNo());
      OrderAftersales cancelAftersales = ((OrderAftersales)(new OrderAftersales()).setId(request.getId())).setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.CANCEL.getValue()));
      result = this.orderAftersalesService.updateByPrimaryKeySelective(cancelAftersales);
      cancelAftersaleNums(goodsList, orderAftersales.getApplyState(), orderAftersales.getOrderDeliveryStatusSnapshot());
      Order updateOrder = ((Order)(new Order()).setId(result.getOrderId())).setMemberNo(result.getMemberNo()).setRefundedDeliveryCost(Objects.isNull(result.getDeliveryCost()) ? BigDecimal.ZERO : BigDecimal.ZERO.subtract(result.getDeliveryCost()));
      updateAftersalesInfoOfOrder(updateOrder);
      SampleOrderInfoDto sampleOrderInfo = this.orderService.getSampleOrderInfo(result.getOrderId(), result.getMemberNo());
      OrderApprovalProcess approvalProcess = getAftersalesApprovalProcess(orderAftersales, OrderAfterSalesStatusEnum.CANCEL, "您已取消售后申请", "取消售后单");
      this.approvalProcessService.insertSelective(approvalProcess);
      QueueMessage<AftersalesActionMessageVO> message = new QueueMessage();
      message.setContent((new AftersalesActionMessageVO()).setId((String)result.getId())
          .setStatus(result.getApplyState())
          .setOldStatus(orderAftersales.getApplyState())
          .setMemberNo(result.getMemberNo()));
      this.messageSender.send(message, "order.aftersales.apply.routing.key");
      int operateType = Objects.equals(result.getSpecialFlag(), Integer.valueOf(BooleanEnum.YES.getValue())) ? OrderAftersalesDeliveryOperatorEnum.CUSTOMER.getValue() : (Objects.equals(request.getStartChannel(), Integer.valueOf(11)) ? OrderAftersalesDeliveryOperatorEnum.WX.getValue() : OrderAftersalesDeliveryOperatorEnum.USER.getValue());
      this.aftersalesMessageSendUtil.setAftersalesStatusMessageVo(result, result.getApplyState(), Integer.valueOf(operateType));
      if (OrderBusinessTypeEnum.GOODS_CUSTOMIZE.getValue() == sampleOrderInfo.getBusinessType().intValue() && OrderAfterSalesStatusEnum.REJECTED
        .getValue() == Integer.parseInt(sampleOrderInfo.getOrderState()))
        return result; 
      OrderAftersalesVO orderAftersalesVO = (OrderAftersalesVO)BeanUtil.copyProperties(orderAftersales, OrderAftersalesVO.class);
      orderAftersalesVO.setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.CANCEL.getValue()));
      orderAftersalesVO.setIsAutoBuyProduct(Boolean.valueOf(this.orderAftersalesService.checkOrderAfterSalesIsSystemAutoBuy((String)orderAftersales.getId(), orderAftersales.getMemberNo())));
      this.orderAftersalesService.notifyMessage(orderAftersalesVO);
    } 
    return result;
  }
  
  private void cancelCheck(boolean managerCancel, OrderAftersales orderAftersales) {
    String oldApplyState = orderAftersales.getApplyState() + "";
    Integer applyType = orderAftersales.getApplyType();
    if (managerCancel) {
      Assert.isTrue(StringUtils.equals(oldApplyState, OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getName()), "仅待审核状态允许操作");
    } else {
      if (StringUtils.equals(oldApplyState, OrderAfterSalesStatusEnum.CANCEL.getName()))
        throw new SystemException(OrderAftersalesErrorCodeEnum.AFTERSALES_ALREADY_CANCEL); 
      if (applyType.equals(Integer.valueOf(OrderAftersalesTypeEnum.RETURN_GOODS_AND_REFUND.getValue()))) {
        Assert.isTrue(OrderAfterSalesStatusEnum.userCanCancelReturnAndRefund().contains(oldApplyState), "当前状态不能取消");
      } else if (applyType.equals(Integer.valueOf(OrderAftersalesTypeEnum.ONLY_REFUND.getValue()))) {
        Assert.isTrue(OrderAfterSalesStatusEnum.userCanCancelOnlyRefund().contains(oldApplyState), "当前状态不能取消");
      } else if (applyType.equals(Integer.valueOf(OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue()))) {
        Assert.isTrue(OrderAfterSalesStatusEnum.userCanCancelExchange().contains(oldApplyState), "当前状态不能取消");
      } else {
        throw new SystemException(ErrorCode.PARAM_ERROR.getCode(), "无效的售后类型");
      } 
    } 
  }
  
  private boolean backAuditReject(OrderAftersales orderAftersales) {
    if (!Objects.equals(orderAftersales.getApplyState(), Integer.valueOf(OrderAfterSalesStatusEnum.REJECTED.getValue())))
      return false; 
    OrderApprovalProcessVO orderApprovalProcessVO = ((OrderApprovalProcessVO)(new OrderApprovalProcessVO()).setDeleteFlag(Integer.valueOf(BooleanEnum.YES.getValue()))).setApprovalState(Integer.valueOf(OrderAfterSalesStatusEnum.AUDIT_PASS.getValue())).setMemberId(orderAftersales.getMemberId()).setMemberNo(Long.valueOf(orderAftersales.getMemberNo().longValue())).setBusinessId((String)orderAftersales.getId());
    List<OrderApprovalProcess> approvalProcessList = this.approvalProcessService.getList(orderApprovalProcessVO);
    if (CollectionUtils.isNotEmpty(approvalProcessList))
      return true; 
    return false;
  }
  
  @TeaTransactional
  public void afterCancel(String aftersalesId, Long memberNo, Integer oldStatus) {
    try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
      aftersaleContext.setMemberNo(memberNo);
      aftersaleContext.setOrderAftersalesId(aftersalesId);
      OrderAftersales orderAftersales = aftersaleContext.getOrderAftersales();
      Assert.isNotNull(aftersaleContext, "售后单不能为空");
      aftersaleContext.setOrderId(orderAftersales.getOrderId());
      aftersaleContext.setMemberId(orderAftersales.getMemberId());
      MemberVo memberVo = aftersaleContext.getMemberVo();
      Boolean specialAfterSaleFlag = aftersaleContext.isSpecialAfterSale();
      Order order = aftersaleContext.getOrder();
      if (specialAfterSaleFlag.booleanValue() && BigDecimal.ZERO.compareTo(orderAftersales.getRecoverIssuedCoinAmount()) < 0)
        aftersalesReturnCoin(orderAftersales); 
      String remark = String.format("用户取消售后，原状态（%s）改为“已取消”；", new Object[] { OrderAfterSalesStatusEnum.getStatusByName(oldStatus.toString()).getDescriptions() });
      OrderLogger orderLogger = getAftersalesLog(orderAftersales, specialAfterSaleFlag, memberVo, OrderLoggerEventTypeEnum.CANCLE_AFTERSALES, remark);
      this.aftersalesMessageSendUtil.sendOrderLoggerMessage(orderLogger);
      Integer applyType = orderAftersales.getApplyType();
      if (OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue() == applyType.intValue()) {
        if (OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue() == oldStatus.intValue()) {
          this.orderAftersalesService.resetProductQuantity(aftersaleContext.getOrderAftersalesGoodsList(), false, false);
        } else if (OrderAfterSalesStatusEnum.WAITING_FOR_BUYER_RETURN.getValue() == oldStatus.intValue() || OrderAfterSalesStatusEnum.AUDIT_PASS
          .getValue() == oldStatus.intValue()) {
          this.orderAftersalesService.resetProductQuantity(aftersaleContext.getOrderAftersalesGoodsList(), true, true);
        } 
      } else if (OrderAftersalesTypeEnum.ONLY_REFUND.getValue() == applyType.intValue()) {
        OrderInvoice redInvoice = aftersaleContext.getLastRedInvoice();
        if (redInvoice != null)
          if (StringUtils.equals(redInvoice.getInvoiceState(), OrderInvoiceStatusEnum.ORDER_INVOICE_STATE_BILLING.getName())) {
            OrderInvoice lastRegularInvoice = aftersaleContext.getLastRegularInvoice();
            this.orderInvoiceService.reDoRegularInvoice(lastRegularInvoice);
          } else if (Arrays.<String>asList(new String[] { OrderInvoiceStatusEnum.ORDER_INVOICE_STATE_RED_TICKET_APPLY_FAILED.getName(), OrderInvoiceStatusEnum.ORDER_INVOICE_STATE_RED_TICKET_APPLY_VOIDED.getName() }).contains(redInvoice.getInvoiceState())) {
            redInvoice.setInvoiceState(OrderInvoiceStatusEnum.ORDER_INVOICE_STATE_CANCEL.getName());
            redInvoice.setUpdateTime(Long.valueOf(Instant.now().toEpochMilli()));
            this.orderInvoiceService.updateOrderInvoiceState(redInvoice);
            this.orderAftersalesService.updateAfterSalesRedInvoiceFlag(aftersalesId, memberNo, OrderAftersalesRedInvoiceFlagEnum.RED_INVOICE_CANCEL, null);
          }  
      } 
    } 
  }
  
  @TeaTransactional
  public AppResult<Boolean> updateOrderAddress(OrderAddressModifyRequest request) {
    try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
      Long memberUserId = MemberUtils.getMemberUserId();
      aftersaleContext.setMemberId(String.valueOf(memberUserId));
      aftersaleContext.setOrderId(request.getOrderId());
      Order order = aftersaleContext.getOrder();
      Assert.isNotNull(order, "订单不存在");
      OrderAddressModifyUtil.checkModifyAddress(order.getOrderState(), order.getBusinessType(), request.getStartChannel(), order.getModifyAddressCount());
      MemberVo memberVo = aftersaleContext.getMemberVo();
      Assert.isNotNull(memberVo, "会员信息不存在");
      UserResult<UserAddressDubbo> userAddress = this.userCenterShipAddressService.findUserAddress(String.valueOf(memberUserId), request.getAddressId());
      if (logger.isInfoEnabled())
        logger.info("updateOrderAddress 修改订单收货地址，获取用户地址信息 userAddress={}", JsonUtil.toJson(userAddress)); 
      userAddress.assertSuccess();
      UserAddressDubbo address = (UserAddressDubbo)userAddress.getResult();
      if (address == null)
        throw new SystemException(ErrorCode.PARAM_ERROR.getCode(), "获取用户地址信息异常"); 
      OrderAddressVo orderAddressVo = (new OrderAddressVo()).setId(address.getId()).setOrderId(request.getOrderId()).setOrderNo(order.getOrderNo()).setReceiverName(address.getConsignee()).setReceiverPhone(address.getConsigneePhone()).setReceiverAddress(address.getConsigneeFullAddress()).setProvince(address.getConsigneePrivince()).setProvinceCode(address.getConsigneePrivinceCode()).setCity(address.getConsigneeCity()).setCityCode(address.getConsigneeCityCode()).setArea(address.getConsigneeArea()).setAreaCode(address.getConsigneeAreaCode()).setTown(address.getConsigneeTown()).setTownCode(address.getConsigneeTownCode());
      OrderResult<Boolean> modifyOrderAddressResult = this.iSopOrderDubboService.modifyOrderAddress(memberVo, orderAddressVo);
      if (!modifyOrderAddressResult.getSucceed().booleanValue())
        return AppResult.failed(modifyOrderAddressResult.getRetCode(), modifyOrderAddressResult.getRetMsg()); 
      return AppResult.success((new DataApp()).setResult(Boolean.valueOf(true)));
    } 
  }
  
  public AppResult<List<LogisticsDto>> getLogisticsPage(LogisticsVO logisticsVO) {
    if (logger.isDebugEnabled())
      logger.debug("获取快递公司列表，入参：logisticsVO={}", JsonUtil.toJson(logisticsVO)); 
    Assert.isNotNull(logisticsVO, "参数不能为空");
    Assert.isNotNull(logisticsVO.getUseToReturn(), "退货类型不能为空");
    PageResult<LogisticsDto> page = this.logisticsServiceFeign.getPage(logisticsVO);
    if (logger.isDebugEnabled())
      logger.debug("获取快递公司列表，结果：page={}", JsonUtil.toJson(page)); 
    page.assertSuccess();
    if (page.getTotalCount() <= 0)
      return AppResult.success((new DataApp())
          .setResult(Lists.newArrayList())
          .setPaged((new PageAppResult()).setTotalItems(Integer.valueOf(0)).setPageNum(Integer.valueOf(0)))); 
    AppResult<List<LogisticsDto>> paged = AppResult.paged((new DataApp())
        .setResult(page.getResult())
        .setPaged((new PageAppResult())
          .setTotalItems(Integer.valueOf(page.getTotalCount()))
          .setPageNum(Integer.valueOf(page.getPageIndex()))));
    return paged;
  }
  
  public void sendAfterSalesDelayedMessage(AftersalesStatusMessageVo content) {
    logger.info("执行发送延时消息 参数 = {}", JSONUtil.toJsonStr(content));
    Integer status = content.getNewStatus();
    logger.info("延时消息发送状态 = {}", status);
    boolean needSendDelayedMessage = (OrderAfterSalesStatusEnum.REJECTED.getValue() == status.intValue() || OrderAfterSalesStatusEnum.WAITING_FOR_BUYER_RETURN.getValue() == status.intValue());
    logger.info("是否发送延时消息 = {}", Boolean.valueOf(needSendDelayedMessage));
    if (needSendDelayedMessage)
      try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
        aftersaleContext.setOrderAftersalesId(content.getId());
        aftersaleContext.setMemberNo(content.getMemberNo());
        Long delayMillis = Constants.DEFAULT_DELAY_MILLIS;
        OrderAftersales orderAftersales = aftersaleContext.getOrderAftersales();
        Long reApplyEndTime = orderAftersales.getReApplyEndTime();
        logger.info("获取当前售后单 id = {} 延时时长 = {}", content.getId(), reApplyEndTime);
        if (Objects.nonNull(reApplyEndTime))
          delayMillis = Long.valueOf(reApplyEndTime.longValue() - DateUtil.getCurrentMillis().longValue()); 
        logger.info("是否发送延时消息 延时时长 = {}", delayMillis);
        AftersalesTimeOutMessageVo message = new AftersalesTimeOutMessageVo();
        message.setId(content.getId());
        message.setMemberNo(content.getMemberNo());
        message.setTimeOut(orderAftersales.getReApplyEndTime());
        QueueMessage<AftersalesTimeOutMessageVo> queueMessage = new QueueMessage();
        queueMessage.setXDelay(Integer.valueOf(delayMillis.intValue()));
        queueMessage.setTopic(true);
        queueMessage.setToExchange("trade.delay.exchange");
        queueMessage.setContent(message);
        logger.info("是否发送延时消息 延时消息内容 = {}", JSON.toJSONString(queueMessage));
        this.messageSender.sendTopic(queueMessage, "after.sales.timeout.auto.routing.key");
      }  
  }
  
  @ExclusiveLock(key = "aftersales.timeout.id:", spel = "#p0.id")
  public void afterSalesUserExecutorTimeOut(AftersalesTimeOutMessageVo content) {
    String afterSalesId = content.getId();
    Assert.isNotBlank(afterSalesId, "售后单ID不能为空");
    Long memberNo = content.getMemberNo();
    Assert.isNotNull(memberNo, "用户编码不能为空");
    try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
      aftersaleContext.setOrderAftersalesId(afterSalesId);
      aftersaleContext.setMemberNo(memberNo);
      OrderAftersales orderAftersales = aftersaleContext.getOrderAftersales();
      Long reApplyEndTime = orderAftersales.getReApplyEndTime();
      if (!reApplyEndTime.equals(content.getTimeOut()))
        return; 
      Integer applyType = orderAftersales.getApplyType();
      if (OrderAfterSalesStatusEnum.REJECTED.getValue() == orderAftersales.getApplyState().intValue()) {
        this.orderAftersalesService.doAutoClose(((OrderAftersalesVO)(new OrderAftersalesVO()).setId(content.getId())).setMemberNo(content.getMemberNo()));
      } else if (OrderAfterSalesStatusEnum.WAITING_FOR_BUYER_RETURN.getValue() == orderAftersales.getApplyState().intValue()) {
        this.orderAftersalesService.doAutoReject(content.getId(), content.getMemberNo());
      } 
    } 
  }
  
  private void aftersalesReturnCoin(OrderAftersales orderAftersales) {
    CoinVo coin = new CoinVo();
    coin.setUserId(Long.valueOf(orderAftersales.getMemberId()));
    coin.setOrderNo(orderAftersales.getOrderNo());
    coin.setRefundOrderNo(orderAftersales.getAftersalesNo());
    coin.setSource(Integer.valueOf(SourceEnum.APP.getValue()));
    coin.setPlatform(Integer.valueOf(ProductEnum.YESTAE_MALL.getValue()));
    coin.setAmount(orderAftersales.getRecoverIssuedCoinAmount());
    coin.setBizTypeEnum(BizTypeEnum.AFTERSALES_CANCEL_RETURN);
    if (logger.isInfoEnabled())
      logger.info("aftersalesReturnCoin param={}", JsonUtil.toJson(coin)); 
    CoinResult<CoinDto> coinDtoCoinResult = this.coinDubboService.aftersalesReturnCoin(coin);
    if (logger.isInfoEnabled())
      logger.info("aftersalesReturnCoin 调用受益券返还接口完成：result={}", JsonUtil.toJson(coinDtoCoinResult)); 
    if (coinDtoCoinResult == null)
      throw new SystemException(ErrorCode.SYSTEM_ERROR.getCode(), "调用受益券返还接口异常"); 
    if (!coinDtoCoinResult.isSucceed().booleanValue())
      throw new SystemException(ErrorCode.SYSTEM_ERROR.getCode(), "调用受益券返还接口异常，msg=" + coinDtoCoinResult.getRetMsg()); 
  }
  
  private Boolean checkAftersalesAllFinished(List<OrderAftersales> allAftersalesList) {
    List<Integer> finishedStatusList = Arrays.asList(new Integer[] { Integer.valueOf(OrderAfterSalesStatusEnum.DONE.getValue()), Integer.valueOf(OrderAfterSalesStatusEnum.CANCEL.getValue()), Integer.valueOf(OrderAfterSalesStatusEnum.CLOSED.getValue()) });
    return Boolean.valueOf(allAftersalesList.stream().allMatch(o -> finishedStatusList.contains(o.getApplyState())));
  }
  
  private void cancelAftersaleNums(List<OrderAftersalesGoods> goodsList, Integer aftersalesState, Integer orderDeliveryStatusSnapshot) {
    for (OrderAftersalesGoods orderAftersalesGoods : goodsList) {
      OrderAftersalesGoodsVO orderAftersalesGoodsVO = (OrderAftersalesGoodsVO)BeanUtil.copyProperties(orderAftersalesGoods, OrderAftersalesGoodsVO.class);
      if (Objects.equals(aftersalesState, Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue())) || 
        Objects.equals(aftersalesState, Integer.valueOf(OrderAfterSalesStatusEnum.REJECTED.getValue())))
        orderAftersalesGoodsVO.setCheckAmount(null)
          .setCheckCoinAmount(null)
          .setCheckCostAmount(null); 
      orderAftersalesGoodsVO.setDeliverState(orderDeliveryStatusSnapshot.toString());
      this.orderGoodsService.cancelAftersaleNums(orderAftersalesGoodsVO);
    } 
  }
  
  @TeaTransactional
  public void afterStatusChanged(AftersalesStatusMessageVo content) {
    Assert.isNotNull(content, "售后状态变更不能为空");
    Assert.isNotNull(content.getId(), "售后单id不能为空");
    Assert.isNotNull(content.getNewStatus(), "售后状态不能为空");
    OrderAftersales orderAftersales = this.orderAftersalesService.getByPrimaryKey(((OrderAftersales)(new OrderAftersales()).setId(content.getId())).setMemberNo(content.getMemberNo()));
    Assert.isNotNull(orderAftersales, "售后单不能为空");
    List<OrderAftersalesGoods> aftersalesGoods = this.orderAftersalesGoodsService.getList((new OrderAftersalesGoodsVO()).setBizId((String)orderAftersales.getId()).setMemberNo(orderAftersales.getMemberNo()));
    Assert.isNotNull(aftersalesGoods, "售后商品不能为空");
    if (OrderAfterSalesStatusEnum.DONE.getValue() == content.getNewStatus().intValue()) {
      OrderAftersales updateAfterSales = ((OrderAftersales)(new OrderAftersales()).setId(content.getId())).setMemberNo(content.getMemberNo()).setCheckState(Integer.valueOf(OrderApprovalApprovalStatusEnum.APPROVAL_OVER.getValue()));
      this.orderAftersalesService.updateByPrimaryKeySelective(updateAfterSales);
    } 
    for (OrderAftersalesGoods aftersalesGood : aftersalesGoods) {
      OrderAftersalesGoodsVO orderAftersalesGoodsVO = ((OrderAftersalesGoodsVO)(new OrderAftersalesGoodsVO()).setOrderGoodsId(aftersalesGood.getOrderGoodsId()).setStatus(content.getNewStatus())).setApplyType(aftersalesGood.getApplyType()).setReApplyEndTime(orderAftersales.getReApplyEndTime()).setMemberNo(orderAftersales.getMemberNo()).setBizId(aftersalesGood.getBizId());
      orderAftersalesGoodsVO.setDeliverState(orderAftersales.getOrderDeliveryStatusSnapshot() + "");
      if (Objects.equals(Integer.valueOf(OrderAfterSalesStatusEnum.DONE.getValue()), content.getNewStatus()) && Objects.equals(Integer.valueOf(OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue()), orderAftersales.getApplyType()))
        orderAftersalesGoodsVO.setGoodsNums(aftersalesGood.getGoodsNums()); 
      this.orderGoodsService.updateApportionAfterSalesState(orderAftersalesGoodsVO);
    } 
    List<OrderAftersales> allAftersalesList = this.orderAftersalesService.getList((new OrderAftersalesVO()).setOrderId(orderAftersales.getOrderId()).setMemberNo(orderAftersales.getMemberNo()));
    if (Objects.equals(content.getNewStatus(), Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue())))
      tryCloseOtherAftersales(aftersalesGoods, allAftersalesList); 
    Boolean allFinished = checkAftersalesAllFinished(allAftersalesList);
    String aftersalesStatus = allFinished.booleanValue() ? OrderAfterSalesProcessEnum.FINISH.getName() : OrderAfterSalesProcessEnum.PROCESSING.getName();
    Order order = ((Order)(new Order()).setId(orderAftersales.getOrderId())).setAftersalesState(aftersalesStatus).setMemberNo(orderAftersales.getMemberNo());
    if (allFinished.booleanValue()) {
      setOrderStatus(allAftersalesList, order);
      String orderState = order.getOrderState();
      List<String> finishStatusList = Arrays.asList(new String[] { OrderStatusEnum.DEAL_CLOSE.getName(), OrderStatusEnum.DEAL_DONE.getName() });
      Order oldOrder = this.orderService.getByPrimaryKey(((Order)(new Order()).setId(orderAftersales.getOrderId())).setMemberNo(orderAftersales.getMemberNo()));
      boolean orderAfterSalesTimeHasExpire = (Objects.isNull(oldOrder.getAftersalesTime()) || DateUtil.getCurrentMillis().longValue() > oldOrder.getAftersalesTime().longValue());
      if (orderAfterSalesTimeHasExpire && (finishStatusList.contains(oldOrder.getOrderState()) || finishStatusList.contains(order.getOrderState()))) {
        order.setFinishState(Integer.valueOf(OrderFinishStateEnum.FINISH.getValue()));
        order.setFinishTime(DateUtil.getCurrentMillis());
        this.thirdService.sendOrderFinishMsgForRefund(oldOrder);
        this.jedisClient.sadd("send_aftersales_market_msg_orderid_set", new String[] { (String)order.getId() });
      } 
      if (OrderStatusEnum.DEAL_CLOSE.getName().equals(orderState))
        this.aftersalesMessageSendUtil.sendOrderCloseMessage(oldOrder); 
    } 
    if (logger.isDebugEnabled())
      logger.debug("更新订单状态 order={}", JsonUtil.toJson(order)); 
    this.orderService.updateOrderAfterSalesState(order);
    updateInvoiceStateCancel(order);
  }
  
  private void updateInvoiceStateCancel(Order order) {
    if (OrderStatusEnum.DEAL_CLOSE.getName().equals(order.getOrderState()) && (
      
      StringUtils.isEmpty(order.getReceiveState()) || (
      StringUtils.isNotEmpty(order.getReceiveState()) && OrderReceiveStateEnum.UN_RECEIVE.getName().equals(order.getReceiveState())))) {
      OrderInvoiceVO orderInvoiceVO = (new OrderInvoiceVO()).setOrderId((String)order.getId()).setMemberNo(order.getMemberNo());
      List<OrderInvoice> orderInvoiceList = this.orderInvoiceService.getList(orderInvoiceVO);
      if (CollectionUtils.isNotEmpty(orderInvoiceList)) {
        OrderInvoice orderInvoice = orderInvoiceList.get(0);
        orderInvoice.setInvoiceState(OrderInvoiceStatusEnum.ORDER_INVOICE_STATE_CANCEL.getName());
        orderInvoice.setUpdateTime(DateUtil.getCurrentMillis());
        this.orderInvoiceService.updateOrderInvoiceState(orderInvoice);
      } 
    } 
  }
  
  private void setOrderStatus(List<OrderAftersales> allAftersalesList, Order order) {
    Order orderDb = this.orderService.getByPrimaryKey(order);
    if (order != null) {
      List<String> aftersalesIdList = (List<String>)allAftersalesList.stream().filter(aftersales -> ToolUtil.equals(aftersales.getApplyState() + "", OrderAfterSalesStatusEnum.DONE.getName())).map(TeaBaseEntity::getId).collect(Collectors.toList());
      if (CollectionUtil.isEmpty(aftersalesIdList))
        return; 
      List<OrderAftersalesGoods> goodsList = this.orderAftersalesGoodsService.getList((new OrderAftersalesGoodsVO()).setBizIdList(aftersalesIdList));
      BigDecimal payAmountTotal = goodsList.stream().map(OrderAftersalesGoods::getCheckAmount).reduce(BigDecimal.ZERO, BigDecimal::add);
      BigDecimal coinAmountTotal = goodsList.stream().map(OrderAftersalesGoods::getCheckCoinAmount).reduce(BigDecimal.ZERO, BigDecimal::add);
      BigDecimal costAmountTotal = goodsList.stream().map(OrderAftersalesGoods::getCheckCostAmount).reduce(BigDecimal.ZERO, BigDecimal::add);
      BigDecimal totalAmount = payAmountTotal.add(coinAmountTotal).add(costAmountTotal);
      BigDecimal orderTotalAmount = (ToolUtil.isNotEmpty(orderDb.getPayAmount()) ? orderDb.getPayAmount() : BigDecimal.ZERO).add(ToolUtil.isNotEmpty(orderDb.getPointPmtNum()) ? orderDb.getPointPmtNum() : BigDecimal.ZERO);
      if (logger.isInfoEnabled())
        logger.info("售后金额汇总={}，订单金额汇总={}", totalAmount, orderTotalAmount); 
      String orderState = orderDb.getOrderState();
      if (!OrderStatusEnum.DEAL_CLOSE.getName().equals(orderState) && totalAmount.compareTo(orderTotalAmount) == 0)
        order.setOrderState(OrderStatusEnum.DEAL_CLOSE.getName()); 
      order.setReceiveState(orderDb.getReceiveState());
    } 
  }
  
  private void tryCloseOtherAftersales(List<OrderAftersalesGoods> aftersalesGoods, List<OrderAftersales> allAftersalesList) {
    long now = Instant.now().toEpochMilli();
    String aftersalesId = (String)((OrderAftersalesGoods)aftersalesGoods.get(0)).getId();
    List<String> reApplyIds = (List<String>)allAftersalesList.stream().filter(o -> (Objects.equals(o.getApplyState(), Integer.valueOf(OrderAfterSalesStatusEnum.REJECTED.getValue())) && o.getReApplyEndTime().longValue() > now)).map(TeaBaseEntity::getId).collect(Collectors.toList());
    if (CollectionUtil.isEmpty(reApplyIds)) {
      logger.debug("tryCloseOtherAftersales 没有其他可重新发起的售后单 aftersalesId={}", aftersalesId);
      return;
    } 
    List<String> orderGoodsIds = (List<String>)aftersalesGoods.stream().map(OrderAftersalesGoods::getOrderGoodsId).collect(Collectors.toList());
    OrderAftersalesGoodsVO orderAftersalesGoodsVO = (new OrderAftersalesGoodsVO()).setBizIdList(reApplyIds).setOrderGoodsIdList(orderGoodsIds).setMemberNo(((OrderAftersales)allAftersalesList.get(0)).getMemberNo());
    List<OrderAftersalesGoods> reApplyAftersalesGoodsIds = this.orderAftersalesGoodsService.getList(orderAftersalesGoodsVO);
    if (CollectionUtil.isEmpty(reApplyAftersalesGoodsIds)) {
      logger.debug("tryCloseOtherAftersales 其他可重新发起的售后单不包含本次售后的商品 aftersalesId={}", aftersalesId);
      return;
    } 
    Set<String> closedAfter = new HashSet<>();
    for (OrderAftersalesGoods closeAftersales : reApplyAftersalesGoodsIds) {
      if (closedAfter.contains(closeAftersales.getBizId()))
        continue; 
      this.orderAftersalesService.doAutoClose(((OrderAftersalesVO)(new OrderAftersalesVO()).setId(closeAftersales.getId())).setMemberNo(closeAftersales.getMemberNo()));
      closedAfter.add(closeAftersales.getBizId());
    } 
  }
  
  @TeaTransactional
  public void afterApply(String aftersalesId, Long memberNo, String oldAftersaleId, Boolean exchangeModifyAddressFlag) {
    try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
      String remark;
      aftersaleContext.setMemberNo(memberNo);
      aftersaleContext.setOrderAftersalesId(aftersalesId);
      OrderAftersales orderAftersales = aftersaleContext.getOrderAftersales();
      Assert.isNotNull(aftersaleContext, "售后单不能为空");
      aftersaleContext.setOrderId(orderAftersales.getOrderId());
      aftersaleContext.setMemberId(orderAftersales.getMemberId());
      List<OrderAftersalesGoods> goodsList = aftersaleContext.getOrderAftersalesGoodsList();
      MemberVo memberVo = aftersaleContext.getMemberVo();
      Boolean specialAfterSaleFlag = aftersaleContext.isSpecialAfterSale();
      Order order = aftersaleContext.getOrder();
      if (StringUtils.isNotEmpty(orderAftersales.getParentId())) {
        OrderAftersales parentAftersales = this.orderAftersalesService.getByPrimaryKey(((OrderAftersales)(new OrderAftersales()).setId(orderAftersales.getParentId())).setMemberNo(memberNo));
        remark = String.format("创建售后单，状态“待审核”，因此单据退款后已不符合随手买参与条件，且随手买商品退货仓不同系统自动创建此售后，关联售后单：%s；", new Object[] { parentAftersales.getAftersalesNo() });
      } else if (StringUtils.isNotEmpty(orderAftersales.getChildIds())) {
        List<String> childIds = JSONArray.parseArray(orderAftersales.getChildIds(), String.class);
        OrderAftersales childAftersales = this.orderAftersalesService.getByPrimaryKey(((OrderAftersales)(new OrderAftersales()).setId(childIds.get(0))).setMemberNo(memberNo));
        remark = String.format("创建售后单，状态“待审核”，因此单据退款后已不符合随手买参与条件，且随手买商品退货仓不同系统了随手买售后：%s；", new Object[] { childAftersales.getAftersalesNo() });
      } else {
        remark = "创建售后单，状态“待审核”；";
      } 
      OrderLogger orderLogger = getAftersalesLog(orderAftersales, specialAfterSaleFlag, memberVo, OrderLoggerEventTypeEnum.CREATE, remark);
      this.aftersalesMessageSendUtil.sendOrderLoggerMessage(orderLogger);
      if (exchangeModifyAddressFlag.booleanValue()) {
        List<OrderAddress> orderAddressList = this.orderAddressService.getList((new OrderAddressVO()).setOrderId((String)order.getId()).setMemberNo(order.getMemberNo()));
        OrderAddress orderAddress = orderAddressList.get(0);
        List<OrderAftersalesAddress> orderAftersalesAddresses = this.orderAftersalesAddressService.getList((new OrderAftersalesAddressVO()).setAftersalesId((String)orderAftersales.getId()).setMemberNo(orderAftersales.getMemberNo()));
        OrderAftersalesAddress orderAftersalesAddress = orderAftersalesAddresses.get(0);
        remark = String.format("原地址（%s，%s）改为（%s，%s）", new Object[] { orderAddress
              .getProvince() + orderAddress.getCity() + orderAddress.getArea() + (StringUtils.isEmpty(orderAddress.getTown()) ? "" : orderAddress.getTown()), orderAddress
              .getReceiverAddress(), orderAftersalesAddress
              .getProvince() + orderAftersalesAddress.getCity() + orderAftersalesAddress.getArea() + (StringUtils.isEmpty(orderAftersalesAddress.getTown()) ? "" : orderAftersalesAddress.getTown()), orderAftersalesAddress
              .getReceiverAddress() });
        orderLogger = getAftersalesLog(orderAftersales, specialAfterSaleFlag, memberVo, OrderLoggerEventTypeEnum.EXCHANGE_MODIFY_ADDRESS, remark);
        this.aftersalesMessageSendUtil.sendOrderLoggerMessage(orderLogger);
      } 
      if (isAutoCheckAftersales(goodsList, order, orderAftersales)) {
        if (logger.isInfoEnabled())
          logger.info("提交售后申请后续操作 售后自动审核 afterApply aftersalesId={}", aftersalesId); 
        ApprovalAftersalesVo approvalAftersalesVo = getApprovalAftersalesVo(memberVo, orderAftersales, goodsList);
        QueueMessage<ApprovalAftersalesVo> message = new QueueMessage();
        message.setContent(approvalAftersalesVo);
        message.setXDelay(Constants.ORDER_AFTER_SALES_AUTO_CHECK_DELAY_MILLIS);
        message.setToExchange("trade.delay.exchange");
        this.messageSender.sendTopic(message, "order.aftersales.auto.audit.delay");
      } 
      if (StringUtils.equals(OrderStatusEnum.UN_DELIVER.getName(), order.getOrderState())) {
        if (logger.isInfoEnabled())
          logger.info("提交售后申请后续操作 未发货售后源子锁单 afterApply aftersalesId={}", aftersalesId); 
        this.atomclient.lockUnDeliveryAftersales(goodsList, orderAftersales);
      } 
      aftersalesMark(order, orderAftersales, memberVo, specialAfterSaleFlag);
      if (specialAfterSaleFlag.booleanValue() && Objects.nonNull(orderAftersales.getRecoverIssuedCoinAmount()) && orderAftersales.getRecoverIssuedCoinAmount().compareTo(BigDecimal.ZERO) > 0) {
        if (logger.isInfoEnabled())
          logger.info("提交售后申请后续操作 特殊售后，扣减受益券 afterApply orderAftersales={}", JsonUtil.toJson(orderAftersales)); 
        recycleCoin(orderAftersales);
      } 
      if (specialAfterSaleFlag.booleanValue()) {
        OrderAftersalesVO query = (new OrderAftersalesVO()).setOrderId((String)order.getId()).setMemberNo(order.getMemberNo()).setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.REJECTED.getValue())).setEndReApplyEndTime(Long.valueOf(Instant.now().toEpochMilli()));
        List<OrderAftersales> list = this.orderAftersalesService.getList(query);
        if (!CollectionUtils.isEmpty(list)) {
          List<String> ids = (List<String>)list.stream().map(TeaBaseEntity::getId).collect(Collectors.toList());
          this.orderAftersalesService.updateBatchByIdsSelective(((OrderAftersalesVO)(new OrderAftersalesVO()).setIdList(ids)).setReApplyEndTime(Long.valueOf(-1L)).setMemberNo(order.getMemberNo()));
        } 
      } 
    } 
  }
  
  private void updateParentAftersalesChilds(String parentId, String id, Long memberNo, String goodsTagInfo) {
    List<String> childIdList;
    OrderAftersales orderAftersales = ((OrderAftersales)(new OrderAftersales()).setId(parentId)).setMemberNo(memberNo);
    OrderAftersales parentAftersales = this.orderAftersalesService.getByPrimaryKey(orderAftersales);
    String childIds = parentAftersales.getChildIds();
    if (StringUtils.isNotEmpty(childIds)) {
      childIdList = JsonUtil.toObjectList(childIds, String.class);
    } else {
      childIdList = new ArrayList<>(1);
    } 
    childIdList.add(id);
    orderAftersales.setChildIds(JsonUtil.toJson(childIdList));
    OrderAftersalesGoodsTag orderAftersalesGoodsTag = (OrderAftersalesGoodsTag)JsonUtil.toObject(parentAftersales.getGoodsTagInfo(), OrderAftersalesGoodsTag.class);
    orderAftersalesGoodsTag.setChildGoodsTagList(((OrderAftersalesGoodsTag)JsonUtil.toObject(goodsTagInfo, OrderAftersalesGoodsTag.class)).getGoodsTagList());
    orderAftersales.setGoodsTagInfo(JsonUtil.toJson(orderAftersalesGoodsTag));
    this.orderAftersalesService.updateByPrimaryKeySelective(orderAftersales);
  }
  
  private void recycleCoin(OrderAftersales orderAftersales) {
    CoinVo coinVo = new CoinVo();
    coinVo.setUserId(Long.valueOf(orderAftersales.getMemberId()));
    coinVo.setOrderNo(orderAftersales.getOrderNo());
    coinVo.setRefundOrderNo(orderAftersales.getAftersalesNo());
    coinVo.setAmount(orderAftersales.getRecoverIssuedCoinAmount());
    coinVo.setSource(Integer.valueOf(SourceEnum.APP.getValue()));
    coinVo.setPlatform(Integer.valueOf(ProductEnum.YESTAE_MALL.getValue()));
    coinVo.setBizTypeEnum(BizTypeEnum.AFTERSALES_DEDUCT);
    if (logger.isInfoEnabled())
      logger.info("调用受益券扣减接口：coinVo={}", JsonUtil.toJson(coinVo)); 
    CoinResult<CoinDto> coinDtoCoinResult = this.coinDubboService.aftersalesDeductCoin(coinVo);
    if (logger.isInfoEnabled())
      logger.info("调用受益券扣减接口完成：orderNo={},result={}", orderAftersales.getOrderNo(), JsonUtil.toJson(coinDtoCoinResult)); 
    if (coinDtoCoinResult != null && !coinDtoCoinResult.isSucceed().booleanValue())
      throw new SystemException(OrderAftersalesErrorCodeEnum.COIN_USE_COUNT_NOT_ENOUGH); 
  }
  
  private void aftersalesMark(Order order, OrderAftersales orderAftersales, MemberVo memberVo, Boolean specialAfterSaleFlag) {
    MarkEnum markEnum = Objects.equals(BooleanEnum.NO.getValue() + "", order.getDeliverState()) ? MarkEnum.AFTERSALES_UN_DELIVER : MarkEnum.AFTERSALES_DELIVER;
    MarkBizRequestVO markBizRequestVO = new MarkBizRequestVO(markEnum, memberVo);
    markBizRequestVO.setBizId((String)orderAftersales.getId());
    markBizRequestVO.setBizNo(orderAftersales.getAftersalesNo());
    if (logger.isInfoEnabled())
      logger.info("调用售后打标接口：markBizRequestVO={}", JsonUtil.toJson(markBizRequestVO)); 
    this.markBizDubboServcie.mark(markBizRequestVO);
    if (specialAfterSaleFlag.booleanValue()) {
      MarkEnum specialEnum = MarkEnum.AFTERSALES_TYPE_SPECIAL;
      MarkBizRequestVO specialMarkBizRequestVO = new MarkBizRequestVO(specialEnum, memberVo);
      specialMarkBizRequestVO.setBizId((String)orderAftersales.getId());
      specialMarkBizRequestVO.setBizNo(orderAftersales.getAftersalesNo());
      if (logger.isInfoEnabled())
        logger.info("调用售后打标接口：specialMarkBizRequestVO={}", JsonUtil.toJson(specialMarkBizRequestVO)); 
      this.markBizDubboServcie.mark(specialMarkBizRequestVO);
    } 
    if (StringUtils.isNotEmpty(orderAftersales.getParentId())) {
      MarkEnum forcedReturn = MarkEnum.FORCED_RETURN;
      MarkBizRequestVO forcedReturnRequest = new MarkBizRequestVO(forcedReturn, memberVo);
      forcedReturnRequest.setBizId((String)orderAftersales.getId());
      forcedReturnRequest.setBizNo(orderAftersales.getAftersalesNo());
      if (logger.isInfoEnabled())
        logger.info("调用售后打标接口：forcedReturnRequest={}", JsonUtil.toJson(forcedReturnRequest)); 
      this.markBizDubboServcie.mark(forcedReturnRequest);
    } 
  }
  
  private UnDeliveryAftersalesLockVo getUnDeliverAftersalesLock(List<OrderAftersalesGoods> autoAftersalesGoodsList, Order order, OrderAftersales orderAftersales) {
    if (logger.isDebugEnabled())
      logger.debug("getUnDeliverAftersalesLock.未发货售后源子锁单.begin, orderNo: {}, aftersalesNo: {}", order.getOrderNo(), orderAftersales.getAftersalesNo()); 
    UnDeliveryAftersalesLockVo aftersalesLockVo = new UnDeliveryAftersalesLockVo();
    aftersalesLockVo.setOrderNo(order.getOrderNo());
    aftersalesLockVo.setAftersalesNo(orderAftersales.getAftersalesNo());
    aftersalesLockVo.setShopId(order.getShopId());
    List<String> subOrderNos = (List<String>)autoAftersalesGoodsList.stream().map(OrderAftersalesGoods::getOrderGoodsId).collect(Collectors.toList());
    String subOrderNoStr = String.join(",", (Iterable)subOrderNos);
    aftersalesLockVo.setSubOrderNos(subOrderNoStr);
    return aftersalesLockVo;
  }
  
  public ApprovalAftersalesVo getApprovalAftersalesVo(MemberVo memberVo, OrderAftersales orderAftersales, List<OrderAftersalesGoods> goodsList) {
    ApprovalAftersalesVo approvalAftersalesVo = new ApprovalAftersalesVo();
    BeanUtils.copyProperties(orderAftersales, approvalAftersalesVo);
    approvalAftersalesVo.setReturnCode("");
    approvalAftersalesVo.setReturnName("");
    approvalAftersalesVo.setCheckState(Integer.valueOf(OrderApprovalApprovalStatusEnum.APPROVAL_OK.getValue()));
    approvalAftersalesVo.setMemberNo(Long.valueOf(memberVo.getMemberNo()));
    approvalAftersalesVo.setMemberName(memberVo.getMemberName());
    approvalAftersalesVo.setAftersalesId((String)orderAftersales.getId());
    approvalAftersalesVo.setOrderNo(orderAftersales.getOrderNo());
    approvalAftersalesVo.setOrderId(orderAftersales.getOrderId());
    approvalAftersalesVo.setSumVerifyRefund(orderAftersales.getPayAmount().toPlainString());
    approvalAftersalesVo.setSumVerifyCoin(orderAftersales.getRefundCoinAmount().toPlainString());
    approvalAftersalesVo.setSumVerifyCost(orderAftersales.getDeliveryCost().toPlainString());
    approvalAftersalesVo.setSumApplyRefund(approvalAftersalesVo.getSumVerifyRefund());
    approvalAftersalesVo.setSumApplyCoin(approvalAftersalesVo.getSumVerifyCoin());
    approvalAftersalesVo.setSumApplyCost(approvalAftersalesVo.getSumVerifyCost());
    String autoCheck = "1";
    approvalAftersalesVo.setAutoCheck(autoCheck);
    return approvalAftersalesVo;
  }
  
  private boolean isAutoCheckAftersales(List<OrderAftersalesGoods> autoAftersalesGoodsList, Order order, OrderAftersales orderAftersales) {
    if (logger.isInfoEnabled())
      logger.info("orderAftersalesAutoAudit.售后单自动过审.begin, orderState: {}, aftersalesNo: {}", order.getOrderState(), orderAftersales.getAftersalesNo()); 
    if (!StringUtils.equals(order.getOrderState(), OrderStatusEnum.UN_DELIVER.getName()) || 
      !StringUtils.equals(OrderAftersalesTypeEnum.ONLY_REFUND.getName(), orderAftersales.getApplyType() + ""))
      return false; 
    List<OrderSetupUnDeliveryProductVO> unDeliveryProductList = this.aftersaleSysBaseSetupUtil.getUnDeliveryProductList();
    if (CollectionUtil.isEmpty(unDeliveryProductList))
      return true; 
    List<String> productIds = (List<String>)unDeliveryProductList.stream().map(o -> o.getProductId()).collect(Collectors.toList());
    if (CollectionUtil.isEmpty(productIds))
      return true; 
    for (OrderAftersalesGoods aftersalesGoods : autoAftersalesGoodsList) {
      if (productIds.contains(aftersalesGoods.getProductId()))
        return false; 
    } 
    return true;
  }
  
  private OrderLogger getAftersalesLog(OrderAftersales orderAftersales, Boolean specialAfterSaleFlag, MemberVo memberVo, OrderLoggerEventTypeEnum eventTypeEnum, String remark) {
    String applyPersonName = specialAfterSaleFlag.booleanValue() ? orderAftersales.getUpdateName() : memberVo.getMemberName();
    OrderLogger orderLogger = new OrderLogger();
    orderLogger.setMemberId(orderAftersales.getMemberId());
    orderLogger.setMemberName(orderAftersales.getMemberName());
    orderLogger.setMemberNo(orderAftersales.getMemberNo());
    orderLogger.setMemberPhone(orderAftersales.getMemberPhone());
    orderLogger.setMemberLevel(String.valueOf(orderAftersales.getMemberLevel()));
    orderLogger.setShopId(orderAftersales.getShopId());
    orderLogger.setShopName(orderAftersales.getShopName());
    orderLogger.setOrderId((String)orderAftersales.getId());
    orderLogger.setOrderNo(orderAftersales.getAftersalesNo());
    if (StringUtils.isBlank(applyPersonName)) {
      orderLogger.setEventPerson("order.service");
    } else {
      orderLogger.setEventPerson(applyPersonName);
    } 
    orderLogger.setEventType(eventTypeEnum.getName());
    orderLogger.setEventTime(Long.valueOf(Instant.now().toEpochMilli()));
    orderLogger.setEventResult(String.valueOf(BooleanEnum.YES.getValue()));
    orderLogger.setRemark(remark);
    orderLogger.setLoggerType(Integer.valueOf(OrderLoggerTypeEnum.LOGGER_TYPE_AFTERSALES.getValue()));
    return orderLogger;
  }
  
  private OrderApprovalProcess getAftersalesApprovalProcess(OrderAftersales orderAftersales, OrderAfterSalesStatusEnum approvalStatusEnum, String approvalMessage, String approvalName) {
    long now = Instant.now().toEpochMilli();
    OrderApprovalProcess approvalProcess = new OrderApprovalProcess();
    ((OrderApprovalProcess)((OrderApprovalProcess)approvalProcess.setMemberId(orderAftersales.getMemberId())
      .setMemberNo(orderAftersales.getMemberNo())
      .setMemberName(orderAftersales.getMemberName())
      .setMemberPhone(orderAftersales.getMemberPhone())
      .setMemberLevel(String.valueOf(orderAftersales.getMemberLevel()))
      .setBusinessId((String)orderAftersales.getId())
      .setApprovalMessage(approvalMessage)
      .setApprovalName(approvalName)
      .setCreateTime(Long.valueOf(now)))
      .setApprovalTime(Long.valueOf(now))
      .setApprovalState(Integer.valueOf(approvalStatusEnum.getValue()))
      .setBusinessType(OrderApprovalProcessBusinessTypeEnum.RETURN_GOODS_AND_REFUND.getName())
      .setDeleteFlag(Integer.valueOf(0)))
      .setShopId(orderAftersales.getShopId())
      .setShopName(orderAftersales.getShopName());
    return approvalProcess;
  }
  
  private void updateAftersalesInfoOfOrder(Order updateOrder) {
    this.orderService.updateAftersalesStatusAndVersion(updateOrder);
  }
  
  private void updateCanAftersaleNums(List<OrderAftersalesGoods> orderAftersalesGoodsList, List<OrderGoods> orderGoodsList, Boolean specialAfterSaleFlag, String deliverState) {
    Map<String, OrderGoods> orderGoodsMap = (Map<String, OrderGoods>)orderGoodsList.stream().collect(Collectors.toMap(TeaBaseEntity::getId, x -> x));
    for (OrderAftersalesGoods orderAftersalesGoods : orderAftersalesGoodsList) {
      OrderAftersalesGoodsVO orderAftersalesGoodsVO = (OrderAftersalesGoodsVO)BeanUtil.copyProperties(orderAftersalesGoods, OrderAftersalesGoodsVO.class);
      if (Objects.equals(orderAftersalesGoods.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.RETURN_GOODS_AND_REFUND.getValue())) || (
        Objects.equals(orderAftersalesGoods.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.ONLY_REFUND.getValue())) && 
        StringUtils.equals(deliverState, OrderDeliveryStatusEnum.UN_DELIVERY.getName()))) {
        OrderGoods orderGoods = orderGoodsMap.get(orderAftersalesGoods.getOrderGoodsId());
        if (orderGoods == null)
          throw new SystemException(OrderGoodsErrorCodeEnum.ORDERGOODS_DATA_UNEXIST); 
        String apportionInfo = orderGoods.getApportionInfo();
        JSONObject apportionJson = JSONObject.parseObject(apportionInfo);
        int goodsNums = orderAftersalesGoods.getGoodsNums().intValue();
        JSONArray amountJsonArray = apportionJson.getJSONArray("amountApportion");
        JSONArray coinJsonArray = apportionJson.getJSONArray("coinApportion");
        BigDecimal amountApportion = BigDecimal.ZERO;
        BigDecimal coinApportion = BigDecimal.ZERO;
        if (!CollectionUtils.isEmpty((Collection)amountJsonArray)) {
          int i;
          for (i = 0; i < amountJsonArray.size() && 
            i < goodsNums; i++)
            amountApportion = amountApportion.add(amountJsonArray.getBigDecimal(i)); 
          for (i = 0; i < coinJsonArray.size() && 
            i < goodsNums; i++)
            coinApportion = coinApportion.add(coinJsonArray.getBigDecimal(i)); 
        } 
        orderAftersalesGoodsVO.setDiffAmount(amountApportion.subtract(orderAftersalesGoods.getPayAmount()));
        orderAftersalesGoodsVO.setDiffCoin(coinApportion.subtract(orderAftersalesGoods.getPointPmtNum()));
        orderAftersalesGoodsVO.setSpecialAfterSaleFlag(specialAfterSaleFlag);
      } 
      orderAftersalesGoodsVO.setDeliverState(deliverState);
      orderAftersalesGoodsVO.setStatus(Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue()));
      int rows = this.orderGoodsService.updateCanAftersaleNums(orderAftersalesGoodsVO);
      if (rows == 0)
        throw new SystemException(OrderGoodsErrorCodeEnum.ORDERGOODS_DATA_UPDATE_FAIL.getValue(), "修改订单商品的可售后数量和分摊信息失败"); 
    } 
  }
  
  @TeaTransactional
  public AftersalesResponse doApply(List<AftersalesRequest> requestList) {
    List<OrderAftersales> aftersalesList = new ArrayList<>(requestList.size());
    OrderAftersales mainAftersales = null;
    String parentId = null;
    for (AftersalesRequest aftersalesRequest : requestList) {
      OrderAftersales orderAftersales = doApply(aftersalesRequest, parentId);
      aftersalesList.add(orderAftersales);
      if (orderAftersales != null && StringUtils.isBlank(orderAftersales.getParentId())) {
        mainAftersales = orderAftersales;
        parentId = (String)mainAftersales.getId();
      } 
    } 
    Assert.isFalse((mainAftersales == null), "未能找到创建的主售后单信息");
    AftersalesResponse response = new AftersalesResponse();
    response.setAftersalesCount(aftersalesList.size())
      .setId((String)mainAftersales.getId())
      .setAftersalesNo(mainAftersales.getAftersalesNo())
      .setChildIds(mainAftersales.getChildIds());
    return response;
  }
  
  private OrderAftersales doApply(AftersalesRequest request, String parentId) {
    if (logger.isDebugEnabled())
      logger.debug("提交售后申请 doApply request={} parentId={}", JsonUtil.toJson(request), parentId); 
    AftersaleContext aftersaleContext = AftersaleContext.getInstance();
    aftersaleContext.setCurrentRequest(request);
    if (CollectionUtil.isNotEmpty(this.aftersalesValidatorList))
      for (AftersalesValidator aftersalesValidator : this.aftersalesValidatorList) {
        String str = aftersalesValidator.submitting();
        if (StringUtils.isNotBlank(str))
          throw new SystemException(ErrorCode.PARAM_ERROR.getCode(), str); 
      }  
    MemberVo memberVo = aftersaleContext.getMemberVo();
    Order order = aftersaleContext.getOrder();
    List<OrderGoods> orderGoodsList = aftersaleContext.getOrderGoodsList();
    AftersalesApportionInfo apportion = aftersaleContext.getApportion(aftersaleContext.getCurrentRequest());
    Boolean specialAfterSaleFlag = aftersaleContext.isSpecialAfterSale();
    Boolean allAfterSaleFlag = aftersaleContext.isAllAftersales();
    Boolean buyAtWillFlag = aftersaleContext.isBuyAtWill();
    Map<String, String> orderReturnWarehouse = aftersaleContext.getOrderReturnWarehouse();
    String returnWarehouseId = orderReturnWarehouse.get(((AftersalesGoodsRequest)request.getGoodsList().get(0)).getOrderGoodsId());
    OrderAftersales orderAftersales = packageOrderAftersales(request, specialAfterSaleFlag, memberVo, order, apportion, allAfterSaleFlag, buyAtWillFlag, parentId, returnWarehouseId);
    List<OrderAftersalesGoods> orderAftersalesGoods = packageOrderAftersalesGoods(orderAftersales, orderGoodsList, request, memberVo, specialAfterSaleFlag, apportion, order);
    OrderAftersales result = this.orderAftersalesService.insertSelective(orderAftersales);
    this.orderAftersalesGoodsService.insertBatch(orderAftersalesGoods);
    saveMedia(request.getMediaList(), result);
    List<OrderAftersalesGoods> goodsList = this.orderAftersalesGoodsService.getList((new OrderAftersalesGoodsVO()).setBizId((String)result.getId()).setMemberNo(result.getMemberNo()));
    updateCanAftersaleNums(goodsList, orderGoodsList, specialAfterSaleFlag, order.getDeliverState());
    Order updateOrder = ((Order)(new Order()).setId(order.getId())).setMemberNo(result.getMemberNo()).setRefundedDeliveryCost(orderAftersales.getDeliveryCost()).setAftersalesState(OrderAfterSalesProcessEnum.PROCESSING.getName());
    updateAftersalesInfoOfOrder(updateOrder);
    if (Objects.equals(request.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue()))) {
      OrderAftersalesAddress address = packageAftersalesAddress(request, result, order);
      this.orderAftersalesAddressService.insertSelective(address);
    } 
    OrderApprovalProcess approvalProcess = getAftersalesApprovalProcess(orderAftersales, OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT, "提交售后审批", "已提交申请，正在受理");
    this.approvalProcessService.insertSelective(approvalProcess);
    if (StringUtils.isNotEmpty(orderAftersales.getParentId()))
      updateParentAftersalesChilds(orderAftersales.getParentId(), (String)orderAftersales.getId(), orderAftersales.getMemberNo(), orderAftersales.getGoodsTagInfo()); 
    QueueMessage<AftersalesActionMessageVO> message = new QueueMessage();
    message.setContent((new AftersalesActionMessageVO())
        .setId((String)result.getId())
        .setMemberNo(result.getMemberNo())
        .setStatus(result.getApplyState())
        .setExchangeModifyAddressFlag(Boolean.valueOf(Objects.nonNull(request.getAddressId())))
        .setOldAftersaleId(request.getOldAftersaleId()));
    this.messageSender.send(message, "order.aftersales.apply.routing.key");
    int operateType = specialAfterSaleFlag.booleanValue() ? OrderAftersalesDeliveryOperatorEnum.CUSTOMER.getValue() : (Objects.equals(request.getStartChannel(), Integer.valueOf(11)) ? OrderAftersalesDeliveryOperatorEnum.WX.getValue() : OrderAftersalesDeliveryOperatorEnum.USER.getValue());
    this.aftersalesMessageSendUtil.setAftersalesStatusMessageVo(result, result.getApplyState(), Integer.valueOf(operateType));
    return result;
  }
  
  private MaterialCertificate saveMedia(List<AftersalesMediaRequest> mediaUrlList, OrderAftersales result) {
    if (CollectionUtils.isEmpty(mediaUrlList))
      return null; 
    long id = SnowflakeIdWorker.nextId();
    MaterialCertificate materialCertificate = new MaterialCertificate();
    ((MaterialCertificate)materialCertificate.setId(String.valueOf(id)))
      .setBizId((String)result.getId())
      .setMemberNo(result.getMemberNo())
      .setCertificateType(Integer.valueOf(CertificateTypeEnum.AFTERSALES.getValue()))
      .setSource(Integer.valueOf(CertificateSourceEnum.MEMBER.getValue()));
    List<MaterialCertificateMedia> list = new ArrayList<>(mediaUrlList.size());
    for (AftersalesMediaRequest media : mediaUrlList)
      list.add((new MaterialCertificateMedia())
          .setMemberNo(result.getMemberNo())
          .setMaterialCertificateId((String)materialCertificate.getId())
          .setMediaType(media.getMediaType())
          .setMediaUrl(media.getMediaUrl())); 
    List<String> mediaIds = this.materialCertificateMediaService.insertBatch(list);
    List<ItemJson> itemJsons = new ArrayList<>(mediaIds.size());
    for (String mediaId : mediaIds) {
      ItemJson itemJson = new ItemJson();
      itemJson.setId(mediaId);
      itemJsons.add(itemJson);
    } 
    materialCertificate.setItemJson(JsonUtil.toJson(itemJsons));
    MaterialCertificate certificate = this.materialCertificateService.insertSelective(materialCertificate);
    OrderAftersales orderAftersales = ((OrderAftersales)(new OrderAftersales()).setId(result.getId())).setMediaId(Long.valueOf(id)).setMemberNo(result.getMemberNo());
    this.orderAftersalesService.updateByPrimaryKeySelective(orderAftersales);
    return certificate;
  }
  
  private OrderAftersalesAddress packageAftersalesAddress(AftersalesRequest request, OrderAftersales orderAftersales, Order order) {
    OrderAftersalesAddressVO orderAftersalesAddressVO = request.getOrderAftersalesAddress();
    Calendar cal = Calendar.getInstance();
    OrderAftersalesAddress orderAftersalesAddress = ((OrderAftersalesAddress)BeanUtil.copyProperties(orderAftersalesAddressVO, OrderAftersalesAddress.class)).setMemberId(orderAftersales.getMemberId()).setMemberNo(orderAftersales.getMemberNo()).setMemberName(orderAftersales.getMemberName()).setMemberPhone(orderAftersales.getMemberPhone()).setMemberLevel(orderAftersales.getMemberLevel()).setAftersalesId((String)orderAftersales.getId()).setAftersalesNo(orderAftersales.getAftersalesNo()).setOrderId(orderAftersales.getOrderId()).setOrderNo(orderAftersales.getOrderNo()).setCreateYear(Integer.valueOf(cal.get(1))).setCreateMonth(Integer.valueOf(cal.get(2) + 1)).setShopId(orderAftersales.getShopId()).setShopName(orderAftersales.getShopName()).setStoreNo(order.getStoreNo()).setStoreName(order.getStoreName());
    return orderAftersalesAddress;
  }
  
  private List<OrderAftersalesGoods> packageOrderAftersalesGoods(OrderAftersales orderAftersales, List<OrderGoods> orderGoodsList, AftersalesRequest request, MemberVo memberVo, Boolean specialAfterSaleFlag, AftersalesApportionInfo apportion, Order order) {
    List<AftersalesGoodsRequest> goodsList = request.getGoodsList();
    List<OrderAftersalesGoods> result = new ArrayList<>(goodsList.size());
    Map<String, OrderGoods> orderGoodsMap = (Map<String, OrderGoods>)orderGoodsList.stream().collect(Collectors.toMap(TeaBaseEntity::getId, x -> x));
    BigDecimal totalAmountApportion = apportion.getTotalAmountApportion().add(apportion.getTotalDiffAmount());
    BigDecimal totalCoinApportion = apportion.getTotalCoinApportion().add(apportion.getTotalDiffCoin());
    BigDecimal payAmount = orderAftersales.getPayAmount();
    BigDecimal refundCoinAmount = orderAftersales.getRefundCoinAmount();
    BigDecimal deliveryCost = (orderAftersales.getDeliveryCost().compareTo(BigDecimal.ZERO) == 0) ? BigDecimal.ZERO : orderAftersales.getDeliveryCost();
    List<BigDecimal> deliveryCostList = ApportionUtils.apportion(deliveryCost, goodsList.size(), 2);
    BigDecimal amountScale = (Objects.isNull(totalAmountApportion) || totalAmountApportion.compareTo(BigDecimal.ZERO) == 0) ? BigDecimal.ONE : payAmount.divide(totalAmountApportion, 10, RoundingMode.HALF_UP);
    BigDecimal coinScale = (Objects.isNull(totalCoinApportion) || totalCoinApportion.compareTo(BigDecimal.ZERO) == 0) ? BigDecimal.ONE : refundCoinAmount.divide(totalCoinApportion, 10, RoundingMode.HALF_UP);
    Map<String, AftersalesGoodsApportionInfo> apportionMap = (Map<String, AftersalesGoodsApportionInfo>)apportion.getAftersalesGoodsApportionInfos().stream().collect(Collectors.toMap(AftersalesGoodsApportionInfo::getOrderGoodsId, x -> x));
    Calendar cal = Calendar.getInstance();
    for (int i = 0; i < goodsList.size(); i++) {
      AftersalesGoodsRequest goodsRequest = goodsList.get(i);
      OrderGoods orderGoods = orderGoodsMap.get(goodsRequest.getOrderGoodsId());
      AftersalesGoodsApportionInfo goodsApportion = apportionMap.get(goodsRequest.getOrderGoodsId());
      Integer goodsNum = goodsRequest.getGoodsNum();
      OrderAftersalesGoods aftersalesGoods = (new OrderAftersalesGoods()).setMemberId(memberVo.getMemberId()).setMemberNo(Long.valueOf(memberVo.getMemberNo())).setMemberName(memberVo.getMemberName()).setMemberPhone(memberVo.getMemberPhone()).setMemberLevel(String.valueOf(memberVo.getMemberLevel())).setBizId((String)orderAftersales.getId()).setOrderId(orderGoods.getOrderId()).setOrderNo(orderGoods.getOrderNo()).setProductId(orderGoods.getProductId()).setProductNo(orderGoods.getProductNo()).setGoodsId(orderGoods.getGoodsId()).setGoodsNo(orderGoods.getGoodsNo()).setGoodsType(orderGoods.getGoodsType()).setGoodsName(orderGoods.getGoodsName()).setGoodsCost(orderGoods.getGoodsCost()).setSalePrice(orderGoods.getSalePrice()).setPromPrice(orderGoods.getPromPrice()).setMemberPrice(orderGoods.getMemberPrice()).setGoodsUnit(orderGoods.getGoodsUnit()).setBuyGoodsNums(orderGoods.getGoodsNums()).setGoodsNums(Float.valueOf(goodsNum.intValue())).setSaleType(orderGoods.getSaleType()).setGoodsSpec(orderGoods.getGoodsSpec()).setGoodsSize(orderGoods.getGoodsSize()).setGoodsWeight(orderGoods.getGoodsWeight()).setCreateYear(Integer.valueOf(cal.get(1))).setCreateMonth(Integer.valueOf(cal.get(2) + 1)).setShopId(orderGoods.getShopId()).setShopName(orderGoods.getShopName()).setCostAmount(deliveryCostList.get(i)).setOrderGoodsId((String)orderGoods.getId()).setDistributionFlag(orderGoods.getDistributionFlag()).setGoodsTag(orderGoods.getGoodsTag()).setGoodsTagDesc(orderGoods.getGoodsTagDesc()).setSalesScene(orderGoods.getSalesScene()).setExternalSkuNo(orderGoods.getExternalSkuNo()).setApplyType(request.getApplyType());
      BigDecimal diffAmount = Objects.isNull(goodsApportion.getDiffAmount()) ? BigDecimal.ZERO : goodsApportion.getDiffAmount();
      BigDecimal doffCoin = Objects.isNull(goodsApportion.getDiffCoin()) ? BigDecimal.ZERO : goodsApportion.getDiffCoin();
      BigDecimal amount = CollectionUtils.isEmpty(goodsApportion.getAmountApportion()) ? BigDecimal.ZERO : goodsApportion.getAmountApportion().stream().reduce(BigDecimal::add).get();
      BigDecimal coin = CollectionUtils.isEmpty(goodsApportion.getCoinApportion()) ? BigDecimal.ZERO : goodsApportion.getCoinApportion().stream().reduce(BigDecimal::add).get();
      if (specialAfterSaleFlag.booleanValue()) {
        if (i == goodsList.size() - 1) {
          aftersalesGoods.setPayAmount(payAmount)
            .setPointPmtNum(refundCoinAmount);
        } else {
          aftersalesGoods.setPayAmount(amount.add(diffAmount).multiply(amountScale).setScale(2, RoundingMode.HALF_UP));
          aftersalesGoods.setPointPmtNum(coin.add(doffCoin).multiply(coinScale).setScale(2, RoundingMode.HALF_UP));
          payAmount = payAmount.subtract(aftersalesGoods.getPayAmount());
          refundCoinAmount = refundCoinAmount.subtract(aftersalesGoods.getPointPmtNum());
        } 
      } else if (Objects.equals(request.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue()))) {
        aftersalesGoods.setPayAmount(BigDecimal.ZERO)
          .setPointPmtNum(BigDecimal.ZERO);
      } else if (i == goodsList.size() - 1) {
        aftersalesGoods.setPayAmount(payAmount)
          .setPointPmtNum(refundCoinAmount);
      } else {
        aftersalesGoods.setPayAmount(amount.add(diffAmount).multiply(amountScale).setScale(2, RoundingMode.HALF_UP));
        aftersalesGoods.setPointPmtNum(coin.add(doffCoin).multiply(coinScale).setScale(2, RoundingMode.HALF_UP));
        payAmount = payAmount.subtract(aftersalesGoods.getPayAmount());
        refundCoinAmount = refundCoinAmount.subtract(aftersalesGoods.getPointPmtNum());
      } 
      result.add(aftersalesGoods);
    } 
    return result;
  }
  
  private OrderAftersales packageOrderAftersales(AftersalesRequest request, Boolean specialAfterSaleFlag, MemberVo memberVo, Order order, AftersalesApportionInfo apportion, Boolean allAfterSaleFlag, Boolean buyAtWillFlag, String parentId, String returnWarehouseId) {
    OrderAftersales orderAftersales = ((OrderAftersales)(new OrderAftersales()).setId(String.valueOf(SnowflakeIdWorker.nextId()))).setMemberId(memberVo.getMemberId()).setMemberNo(Long.valueOf(memberVo.getMemberNo())).setMemberName(memberVo.getMemberName()).setMemberPhone(memberVo.getMemberPhone()).setMemberLevel(memberVo.getMemberLevel()).setAftersalesNo(String.valueOf(SnowflakeIdWorker.nextId())).setOrderNo(order.getOrderNo()).setOrderId((String)order.getId()).setApplyType(request.getApplyType()).setApplyTime(Long.valueOf(Instant.now().toEpochMilli())).setOrderType(order.getOrderType()).setShopId(order.getShopId()).setShopName(order.getShopName()).setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_AUDIT.getValue())).setAftersalesState(Integer.valueOf(BooleanEnum.NO.getValue())).setIsConfirm(Integer.valueOf(Objects.isNull(request.getApplyGoodsState()) ? BooleanEnum.NO.getValue() : request.getApplyGoodsState().intValue())).setSpecialFlag(Integer.valueOf(specialAfterSaleFlag.booleanValue() ? BooleanEnum.YES.getValue() : BooleanEnum.NO.getValue())).setShouldRecoverCoinAmount(order.getReceiveCoinNum()).setDistributionFlag(order.getDistributionFlag()).setStartChannel(request.getStartChannel()).setApplyReason(request.getApplyReason()).setApplyReasonName(request.getApplyReasonName()).setApplyGoodsState(request.getApplyGoodsState()).setOrderStatusSnapshot(order.getOrderState()).setOutAftersaleId(request.getOutAftersaleId()).setOutAftersaleState(request.getOutAftersaleState()).setReturnWarehouseId(returnWarehouseId).setBusinessType(order.getBusinessType()).setContent(request.getContent());
    if (StringUtils.isNoneBlank(new CharSequence[] { order.getDeliverState() }))
      orderAftersales.setOrderDeliveryStatusSnapshot(Integer.valueOf(order.getDeliverState())); 
    OrderAftersalesGoodsTag orderAftersalesGoodsTag = (new OrderAftersalesGoodsTag()).setGoodsTagList((List)request.getGoodsList().stream().map(AftersalesGoodsRequest::getGoodsTag).distinct().collect(Collectors.toList()));
    orderAftersales.setGoodsTagInfo(JsonUtil.toJson(orderAftersalesGoodsTag));
    if (Objects.equals(order.getSource(), Integer.valueOf(OrderSourceEnum.SOURCE_WX_VIDEO.getValue()))) {
      orderAftersales.setSource(Integer.valueOf(OrderSourceEnum.SOURCE_WX_VIDEO.getValue()));
    } else {
      orderAftersales.setSource(Integer.valueOf(OrderSourceEnum.SOURCE_YG_APP.getValue()));
    } 
    if (Objects.equals(Integer.valueOf(Integer.parseInt(order.getDeliverState())), Integer.valueOf(BooleanEnum.NO.getValue()))) {
      orderAftersales.setIsUndeliver(Integer.valueOf(BooleanEnum.YES.getValue()));
    } else {
      orderAftersales.setIsUndeliver(Integer.valueOf(BooleanEnum.NO.getValue()));
    } 
    if (buyAtWillFlag.booleanValue())
      orderAftersales.setParentId(parentId); 
    if (Objects.equals(order.getOrderState(), OrderStatusEnum.UN_DELIVER.getName()) && 
      Objects.equals(request.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.ONLY_REFUND.getValue()))) {
      orderAftersales.setPayAmount(apportion.getTotalAmountApportion())
        .setRefundCoinAmount(apportion.getTotalCoinApportion())
        .setRecoverIssuedCoinAmount(apportion.getTotalRecycleCoinApportion());
    } else if (Objects.equals(request.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue()))) {
      orderAftersales.setPayAmount(BigDecimal.ZERO)
        .setRefundCoinAmount(BigDecimal.ZERO)
        .setRecoverIssuedCoinAmount(BigDecimal.ZERO);
    } else {
      orderAftersales.setPayAmount(request.getPayAmount())
        .setRefundCoinAmount(request.getRefundCoinAmount())
        .setRecoverIssuedCoinAmount(request.getRecoverIssuedCoinAmount());
    } 
    if (specialAfterSaleFlag.booleanValue()) {
      orderAftersales.setDeliveryCost(request.getDeliveryCost())
        .setPayAmount(request.getPayAmount())
        .setRefundCoinAmount(request.getRefundCoinAmount())
        .setRecoverIssuedCoinAmount(request.getRecoverIssuedCoinAmount());
    } else if (Objects.equals(request.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue()))) {
      orderAftersales.setDeliveryCost(BigDecimal.ZERO);
    } else if (allAfterSaleFlag.booleanValue()) {
      if (StringUtils.isNotEmpty(orderAftersales.getParentId())) {
        BigDecimal refundDelivery = order.getDeliveryCost().subtract(Objects.nonNull(order.getRefundedDeliveryCost()) ? order.getRefundedDeliveryCost() : BigDecimal.ZERO).subtract(Objects.nonNull(order.getFreightReductionAmount()) ? order.getFreightReductionAmount() : BigDecimal.ZERO);
        orderAftersales.setDeliveryCost(refundDelivery);
      } else {
        orderAftersales.setDeliveryCost(request.getDeliveryCost());
      } 
    } else {
      orderAftersales.setDeliveryCost(request.getDeliveryCost());
    } 
    return orderAftersales;
  }
  
  @TeaTransactional
  public Boolean interceptUnDelivery(List<String> aftersalesIds) {
    for (String aftersalesId : aftersalesIds) {
      try (AftersaleContext aftersaleContext = AftersaleContext.createContext()) {
        aftersaleContext.setOrderAftersalesId(aftersalesId);
        OrderAftersales orderAftersales = aftersaleContext.getOrderAftersales();
        Assert.isNotNull(orderAftersales, "售后单不能为空");
        aftersaleContext.setOrderId(orderAftersales.getOrderId());
        Order order = aftersaleContext.getOrder();
        Assert.isNotNull(order, "订单不能为空");
        aftersaleContext.setMemberId(orderAftersales.getMemberId());
        MemberVo memberVo = aftersaleContext.getMemberVo();
        Assert.isTrue(Objects.equals(Integer.valueOf(OrderAfterSalesStatusEnum.AUDIT_PASS.getValue()), orderAftersales.getApplyState()), "售后单审核通过状态才能拦截");
        Assert.isTrue(Objects.equals(orderAftersales.getApplyType(), Integer.valueOf(OrderAftersalesTypeEnum.ONLY_REFUND.getValue())), "售后单仅退款类型才能拦截");
        Assert.isTrue(Objects.equals(order.getOrderState(), OrderStatusEnum.UN_DELIVER.getName()), "订单未发货状态才能拦截");
        Assert.isTrue((Objects.isNull(orderAftersales.getCancelState()) || Objects.equals(orderAftersales.getCancelState(), Integer.valueOf(BooleanEnum.YES.getValue()))), "源子取消成功不能拦截");
        OrderAftersales updateOrderAftersales = ((OrderAftersales)(new OrderAftersales()).setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_REFUND.getValue())).setId(aftersalesId)).setMemberNo(orderAftersales.getMemberNo());
        OrderAftersales result = this.orderAftersalesService.updateByPrimaryKeySelective(updateOrderAftersales);
        String remark = String.format("已核实商品未发货，手动操作拦截发货，售后状态改为“%s”；", new Object[] { OrderAfterSalesStatusEnum.WAITING_FOR_REFUND.getDescriptions() });
        OrderLogger orderLogger = getAftersalesLog(result, Boolean.valueOf(true), memberVo, OrderLoggerEventTypeEnum.INTERCEPT_DELIVERY, remark);
        this.aftersalesMessageSendUtil.sendOrderLoggerMessage(orderLogger);
        this.aftersalesMessageSendUtil.sendAftersalesAutoRefundMessage(result);
      } 
    } 
    return Boolean.valueOf(true);
  }
  
  @TeaTransactional
  @ExclusiveLock(key = "order.aftersales.do", spel = "#p0.afterSalesId")
  public Boolean atomOrderAfterSalesStateChange(OrderAfterSalesStateChangeVo changeVo) {
    logger.info("源子售后单通知逻及处理 参数 = {}", JSON.toJSONString(changeVo));
    try (AftersaleContext context = AftersaleContext.createContext()) {
      context.setOrderAftersales(null);
      context.setOrderAftersalesId(changeVo.getAfterSalesId());
      context.setMemberNo(changeVo.getMemberNo());
      OrderAftersales orderAftersales = context.getOrderAftersales();
      if (logger.isInfoEnabled())
        logger.info("源子售后单通知逻及处理,售后单信息={}", JsonUtil.toJson(orderAftersales)); 
      context.setOrderAftersalesId((String)orderAftersales.getId());
      context.setMemberId(orderAftersales.getMemberId());
      Order order = context.getOrder();
      Integer applyState = orderAftersales.getApplyState();
      Integer applyType = orderAftersales.getApplyType();
      OrderAftersales update = new OrderAftersales();
      OrderAfterSalesStatusEnum applyStateEnum = OrderAfterSalesStatusEnum.getStatusByName(applyState + "");
      boolean result = false;
      logger.info("源子售后单通知逻及处理 售后类型 = {}，当前售后单状态 = {}", applyType, applyState);
      if (OrderAftersalesTypeEnum.ONLY_REFUND.getValue() == applyType.intValue() && (OrderAfterSalesStatusEnum.AUDIT_PASS
        .getValue() == applyState.intValue() || OrderAfterSalesStatusEnum.WAITING_FOR_REFUND
        .getValue() == applyState.intValue()) && OrderAfterSalesStatusEnum.DONE
        .getValue() != applyState.intValue() && OrderAfterSalesStatusEnum.CLOSED
        .getValue() != applyState.intValue() && OrderAfterSalesStatusEnum.REJECTED
        .getValue() != applyState.intValue()) {
        Integer isCancelState = changeVo.getIsCancelState();
        update.setId(orderAftersales.getId());
        update.setMemberNo(orderAftersales.getMemberNo());
        update.setCancelState(isCancelState);
        update.setUpdateTime(DateUtil.getCurrentMillis());
        update.setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_REFUND.getValue()));
        String remark1 = "源子订单取消成功，售后状态改为“待退款”";
        this.orderAftersalesService.toSaveOrderLogger(orderAftersales, order, remark1, BizUserUtil.getUserName(), OrderLoggerEventTypeEnum.ATOM_CANCEL_ORDER, OrderLoggerTypeEnum.LOGGER_TYPE_AFTERSALES);
        update = this.orderAftersalesService.updateByPrimaryKeySelective(update);
        sendOrderAfterStatusChanged(orderAftersales, update);
        context.setOrderAftersales(update);
        if (BooleanEnum.YES.getValue() == isCancelState.intValue()) {
          List<OrderAftersalesGoods> orderAftersalesGoodsList = context.getOrderAftersalesGoodsList();
          BigDecimal checkAmount = orderAftersalesGoodsList.stream().filter(goods -> Objects.nonNull(goods.getCheckAmount())).map(goods -> goods.getCheckAmount()).reduce(BigDecimal.ZERO, BigDecimal::add);
          BigDecimal checkCoinAmount = orderAftersalesGoodsList.stream().filter(goods -> Objects.nonNull(goods.getCheckCoinAmount())).map(goods -> goods.getCheckCoinAmount()).reduce(BigDecimal.ZERO, BigDecimal::add);
          BigDecimal checkCostAmount = orderAftersalesGoodsList.stream().filter(goods -> Objects.nonNull(goods.getCheckCostAmount())).map(goods -> goods.getCheckCostAmount()).reduce(BigDecimal.ZERO, BigDecimal::add);
          try {
            logger.info("源子售后单通知逻及处理 售后类型 仅退款 执行手动退款逻辑");
            if (checkAmount.compareTo(BigDecimal.ZERO) == 0 && checkCoinAmount
              .compareTo(BigDecimal.ZERO) == 0 && checkCostAmount
              .compareTo(BigDecimal.ZERO) == 0) {
              Boolean refundResult = this.orderService.doOrderRefundBefore((new OrderRefund())
                  .setOrderId((String)order.getId())
                  .setAftersalesId((String)orderAftersales.getId())
                  .setMemberNo(orderAftersales.getMemberNo())
                  .setRefundAmount(BigDecimal.ZERO)
                  .setRefundCoinAmount(BigDecimal.ZERO)
                  .setAuto(true));
              logger.info("源子售后单通知逻及处理 售后类型 仅退款 执行手动退款逻辑  执行退款结果 = {}", refundResult);
              if (refundResult.booleanValue())
                update.setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.DONE.getValue())); 
            } else {
              try {
                MemberVo memberVo = context.getMemberVo();
                DataResult<Boolean> refundResults = this.autoRefundService.autoRefund(memberVo, (String)orderAftersales.getId());
                logger.info("源子售后单通知逻及处理 售后类型 仅退款 执行手动退款逻辑  执行退款结果 = {}", JSONUtil.toJsonStr(refundResults));
                if (Objects.nonNull(refundResults) && refundResults.isSuccess() && ((Boolean)refundResults.getResult()).booleanValue())
                  update.setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.DONE.getValue())); 
              } catch (Exception e) {
                logger.error("退款失败", e);
              } 
            } 
          } catch (Exception e) {
            logger.error("退款失败", e);
          } 
        } 
        result = Objects.nonNull(update);
      } else if (OrderAftersalesTypeEnum.RETURN_GOODS_AND_REFUND.getValue() == applyType.intValue() && (OrderAfterSalesStatusEnum.WAITING_FOR_SELLER_RETURN_TO_THE_WAREHOUSE
        .getValue() == applyState.intValue() || OrderAfterSalesStatusEnum.WAITING_FOR_BUYER_RETURN
        .getValue() == applyState.intValue() || OrderAfterSalesStatusEnum.AUDIT_PASS
        .getValue() == applyState.intValue()) && OrderAfterSalesStatusEnum.DONE
        .getValue() != applyState.intValue() && OrderAfterSalesStatusEnum.CLOSED
        .getValue() != applyState.intValue() && OrderAfterSalesStatusEnum.REJECTED
        .getValue() != applyState.intValue()) {
        logger.info("源子售后单通知逻及处理 售后类型 退货退款 ");
        update.setId(orderAftersales.getId());
        update.setMemberNo(orderAftersales.getMemberNo());
        update.setApplyState(Integer.valueOf(OrderAfterSalesStatusEnum.WAITING_FOR_REFUND.getValue()));
        update.setReApplyEndTime(Long.valueOf(-1L));
        update.setUpdateTime(DateUtil.getCurrentMillis());
        update = this.orderAftersalesService.updateByPrimaryKeySelective(update);
        sendOrderAfterStatusChanged(orderAftersales, update);
        context.setOrderAftersales(update);
        this.aftersalesMessageSendUtil.sendAftersalesAutoRefundMessage(update);
        result = Objects.nonNull(update);
        String remark1 = "源子订单取消成功，售后状态改为“待退款”";
        this.orderAftersalesService.toSaveOrderLogger(orderAftersales, order, remark1, BizUserUtil.getUserName(), OrderLoggerEventTypeEnum.RETURN_WAREHOUSING, OrderLoggerTypeEnum.LOGGER_TYPE_AFTERSALES);
      } else if (OrderAftersalesTypeEnum.EXCHANGE_GOODS.getValue() == applyType.intValue() && (OrderAfterSalesStatusEnum.WAITING_FOR_SELLER_RETURN_TO_THE_WAREHOUSE
        
        .getValue() == applyState.intValue() || OrderAfterSalesStatusEnum.WAITING_FOR_BUYER_RETURN
        .getValue() == applyState.intValue() || OrderAfterSalesStatusEnum.AUDIT_PASS
        .getValue() == applyState.intValue() || OrderAfterSalesStatusEnum.WAIT_WAREHOUSE_DELIVERY
        .getValue() == applyState.intValue()) && OrderAfterSalesStatusEnum.DONE
        .getValue() != applyState.intValue() && OrderAfterSalesStatusEnum.CLOSED
        .getValue() != applyState.intValue() && OrderAfterSalesStatusEnum.REJECTED
        .getValue() != applyState.intValue()) {
        logger.info("源子售后单通知逻及处理 售后类型 换货");
        List<OrderAftersalesGoods> orderAftersalesGoodsList = context.getOrderAftersalesGoodsList();
        boolean hasSend = orderAftersalesGoodsList.stream().anyMatch(orderAftersalesGoods -> StringUtils.isNoneBlank(new CharSequence[] { orderAftersalesGoods.getLogisticsNo() }));
        logger.info("源子售后单通知逻及处理 售后类型 换货 是否换货先发 = {} ", Boolean.valueOf(hasSend));
        update.setId(orderAftersales.getId());
        update.setMemberNo(orderAftersales.getMemberNo());
        update.setApplyState(Integer.valueOf(hasSend ? OrderAfterSalesStatusEnum.DONE.getValue() : OrderAfterSalesStatusEnum.WAIT_WAREHOUSE_DELIVERY.getValue()));
        update.setUpdateTime(DateUtil.getCurrentMillis());
        update.setReApplyEndTime(Long.valueOf(-1L));
        update = this.orderAftersalesService.updateByPrimaryKeySelective(update);
        result = Objects.nonNull(update);
        sendOrderAfterStatusChanged(orderAftersales, update);
        context.setOrderAftersales(update);
        String remark1 = "原状态（" + applyStateEnum.getDescriptions() + "）改为“待卖家发货”状态；源子退货入库：";
        if (hasSend)
          remark1 = "原状态（" + applyStateEnum.getDescriptions() + "）改为“售后完成”状态；"; 
        for (OrderAftersalesGoods aftersalesGoods : orderAftersalesGoodsList)
          remark1 = remark1 + aftersalesGoods.getGoodsName() + " (" + aftersalesGoods.getGoodsNo() + " " + aftersalesGoods.getGoodsNums() + ")"; 
        this.orderAftersalesService.toSaveOrderLogger(orderAftersales, order, remark1, BizUserUtil.getUserName(), OrderLoggerEventTypeEnum.RETURN_WAREHOUSING, OrderLoggerTypeEnum.LOGGER_TYPE_AFTERSALES);
        if (hasSend) {
          logger.info("源子售后单通知逻及处理 售后类型 换货 售后单状态扭转为售后完成，保存售后流程信息 ");
          OrderApprovalProcess process = new OrderApprovalProcess();
          process.setApprovalState(Integer.valueOf(OrderAfterSalesStatusEnum.DONE.getValue()));
          process.setName("售后完成");
          process.setApprovalMessage("换货包裹已寄出，请注意查收");
          this.orderAftersalesService.saveApprovalProcess("换货包裹已寄出，请注意查收", "SYSTEM", orderAftersales, order, process.getName(), process);
          logger.info("记录售后完成日志");
          String remark2 = "售后完成（全部换货商品都有物流信息）";
          this.orderAftersalesService.toSaveOrderLogger(orderAftersales, order, remark2, BizUserUtil.getUserName(), OrderLoggerEventTypeEnum.AFTERSALES, OrderLoggerTypeEnum.LOGGER_TYPE_AFTERSALES);
        } 
      } 
      if (result) {
        logger.info("源子售后单通知逻及处理 售后单更新成功，执行尝试源子解冻操作 ");
        try {
          logger.info("源子售后单通知逻及处理，尝试执行通知解冻接口 afterSalesId = {}", changeVo.getAfterSalesId());
          List<OrderAftersales> unCompleteOrderAfterSales = this.orderAftersalesService.getUnCompleteOrderAfterSales(orderAftersales.getOrderId(), orderAftersales.getMemberNo());
          boolean needUnFreeze = (CollectionUtils.isEmpty(unCompleteOrderAfterSales) || (unCompleteOrderAfterSales.size() == 1 && ((String)((OrderAftersales)unCompleteOrderAfterSales.get(0)).getId()).equals(changeVo.getAfterSalesId())));
          logger.info("源子售后单通知逻及处理，尝试执行通知解冻接口 是否可以解冻 = {},售后单数量 = {}", Boolean.valueOf(needUnFreeze), Integer.valueOf(unCompleteOrderAfterSales.size()));
          if (needUnFreeze) {
            AtomResult atomResult = this.atomclient.unFreeze(orderAftersales.getOrderNo(), null, orderAftersales.getShopId());
            logger.info("源子售后单通知逻及处理，尝试执行通知解冻接口 请求参数 platOrderNo = {}, 结果 = {} ", orderAftersales.getAftersalesNo(), JSON.toJSON(atomResult));
            if (Objects.isNull(atomResult) || !atomResult.getSuccess().booleanValue())
              logger.error("尝试调用源子解冻订单失败 订单No = {}", orderAftersales.getOrderNo()); 
          } 
        } catch (Exception e) {
          logger.error("源子AG接口通知异常", e);
        } 
      } 
      return Boolean.valueOf(result);
    } 
  }
  
  private void sendOrderAfterStatusChanged(OrderAftersales orderAftersales, OrderAftersales update) {
    int operateType = Objects.equals(orderAftersales.getSpecialFlag(), Integer.valueOf(BooleanEnum.YES.getValue())) ? OrderAftersalesDeliveryOperatorEnum.CUSTOMER.getValue() : OrderAftersalesDeliveryOperatorEnum.USER.getValue();
    this.aftersalesMessageSendUtil.setAftersalesStatusMessageVo(update, update.getApplyState(), Integer.valueOf(operateType));
  }
  
  public void sendUserGrowthMessage(AftersalesStatusMessageVo content) {
    logger.info("发送成长值消息参数 = {}", JSONUtil.toJsonStr(content));
    Assert.isNotNull(content, "发送成长值参数不能为空");
    Assert.isNotNull(content.getNewStatus(), "售后单的最新状态不能为空");
    Assert.isNotNull(content.getMemberNo(), "售后单用户编码不能为空");
    Assert.isNotBlank(content.getId(), "售后单ID不能为空");
    try (AftersaleContext context = AftersaleContext.createContext()) {
      context.setMemberNo(content.getMemberNo());
      context.setOrderAftersalesId(content.getId());
      OrderAftersales orderAftersales = context.getOrderAftersales();
      String orderId = orderAftersales.getOrderId();
      context.setOrderId(orderId);
      Order order = context.getOrder();
      List<OrderAftersales> unCompleteOrderAfterSales = this.orderAftersalesService.getUnCompleteOrderAfterSalesWithoutReject(orderId, context.getMemberNo());
      logger.info("售后单未完成不包含驳回状态数量  = {}", Integer.valueOf(unCompleteOrderAfterSales.size()));
      boolean orderHadOutOfAfterSalesTime = (Objects.nonNull(order.getAftersalesTime()) && DateUtil.getCurrentMillis().longValue() > order.getAftersalesTime().longValue());
      logger.info("检测是否需要发送成长值消息 是否存在未完成订单 {}", Boolean.valueOf(CollectionUtils.isEmpty(unCompleteOrderAfterSales)));
      logger.info("检测是否需要发送成长值消息 订单是否已过受后期 {}", Boolean.valueOf(orderHadOutOfAfterSalesTime));
      logger.info("检测是否需要发送成长值消息");
      if (CollectionUtils.isEmpty(unCompleteOrderAfterSales) && orderHadOutOfAfterSalesTime) {
        GrowthMessageVO growthMessageVO = new GrowthMessageVO();
        growthMessageVO.setCreateTime(DateUtil.getCurrentMillis());
        growthMessageVO.setBizId(orderAftersales.getOrderId());
        growthMessageVO.setUserId(Long.valueOf(orderAftersales.getMemberId()));
        growthMessageVO.setId(String.valueOf(SnowflakeIdWorker.nextId()));
        QueueMessage<GrowthMessageVO> queueMessage = new QueueMessage();
        queueMessage.setToExchange("exchange-member-growth");
        queueMessage.setContent(growthMessageVO);
        logger.info("检测是否需要发送成长值消息 发消息内容 = {}", JSON.toJSONString(queueMessage));
        this.messageSender.send(queueMessage, "rk-member-growth");
      } 
    } 
  }
  
  @TeaTransactional
  public boolean fixAfterSalesOnRunning(String afterSalesId, Long memberNo) {
    if (logger.isInfoEnabled())
      logger.info("fixAfterSalesOnRunning afterSalesId = {}, memberNo = {}", afterSalesId, memberNo); 
    Assert.isNotBlank(afterSalesId, "售后单ID不能为空");
    Assert.isNotNull(memberNo, "用户编码不能为空");
    try (AftersaleContext context = AftersaleContext.createContext()) {
      context.setMemberNo(memberNo);
      context.setOrderAftersalesId(afterSalesId);
      OrderAftersales orderAftersales = context.getOrderAftersales();
      Assert.isNotNull(orderAftersales, "未查询到售后信息");
      context.setOrderId(orderAftersales.getOrderId());
      if (logger.isInfoEnabled())
        logger.info("aftersales order id = {} ,orderNO = {}", orderAftersales.getOrderId(), orderAftersales.getOrderNo()); 
      Integer applyType = orderAftersales.getApplyType();
      Integer applyState = orderAftersales.getApplyState();
      Integer checkState = orderAftersales.getCheckState();
      Order order = context.getOrder();
      List<OrderGoods> orderGoodsList = context.getOrderGoodsList();
      boolean needUpdateAfterVersion = Objects.isNull(order.getAftersaleVersion());
      if (needUpdateAfterVersion)
        this.orderService.updateOrderAfterVersionAndOrderGoodsApportionInfo(order, orderGoodsList, false); 
    } 
    return true;
  }
  
  public void executorCoin(AftersalesStatusMessageVo content) {
    logger.info("售后完成处理受益权 参数 = {}", JSONUtil.toJsonStr(content));
    try (AftersaleContext context = AftersaleContext.createContext()) {
      context.setOrderAftersalesId(content.getId());
      context.setMemberNo(content.getMemberNo());
      OrderAftersales orderAftersales = context.getOrderAftersales();
      if (Objects.isNull(orderAftersales))
        return; 
      context.setOrderId(orderAftersales.getOrderId());
      Order order = context.getOrder();
      Long aftersalesTime = order.getAftersalesTime();
      Long currentMillis = DateUtil.getCurrentMillis();
      if (aftersalesTime != null && currentMillis.longValue() > aftersalesTime.longValue() && (Objects.isNull(order.getReceiveCoinNum()) || BigDecimal.ZERO.compareTo(order.getReceiveCoinNum()) == 0))
        doExecutorCoin((String)order.getId(), order.getMemberNo()); 
    } 
  }
  
  private void doExecutorCoin(String orderId, Long memberNo) {
    logger.info("售后处理受益权参数 orderId = {},memberNo  = {}", orderId, memberNo);
    try(RedisLock redisLock = this.distributedLock.lock("order.after.sales.executor.coin" + orderId); 
        AftersaleContext context = AftersaleContext.createContext()) {
      context.setOrderId(orderId);
      context.setMemberNo(memberNo);
      Order order = context.getOrder();
      if (Objects.isNull(order))
        return; 
      List<OrderGoods> orderGoodsList = context.getOrderGoodsList();
      order.setOrderGoodsList(orderGoodsList);
      Long currentMillis = DateUtil.getCurrentMillis();
      Long aftersalesTime = order.getAftersalesTime();
      if (Objects.isNull(aftersalesTime) || currentMillis.longValue() < aftersalesTime.longValue()) {
        logger.info("当前售后单关联订单未超过售后最大期限，不执行发放受益权逻辑");
        return;
      } 
      order.setMemberId(order.getMemberId());
      BigDecimal payAmount = BigDecimal.ZERO;
      List<OrderAftersales> orderAfterSalesList = packageAfterSalesGoods(memberNo, context);
      boolean handlerCoin = aftersalesHandlerCoin(order, orderAfterSalesList);
      if (handlerCoin)
        this.jedisClient.sadd("send_coin_msg_orderid_set", new String[] { orderId }); 
    } 
  }
  
  private boolean aftersalesHandlerCoin(Order order, List<OrderAftersales> orderAfterSalesList) {
    Long memberNo = order.getMemberNo();
    String orderId = (String)order.getId();
    String orderNo = order.getOrderNo();
    List<OrderAftersales> unCompleteOrderAfterSalesWithoutReject = this.orderAftersalesService.getUnCompleteOrderAfterSalesWithoutReject(orderId, memberNo);
    if (!CollectionUtils.isEmpty(unCompleteOrderAfterSalesWithoutReject)) {
      logger.info("订单号有未完结的售后单：orderId = {},orderNo = {}", orderId, orderNo);
      return false;
    } 
    orderAfterSalesList.removeIf(afterSales -> (OrderAftersalesTypeEnum.ONLY_REFUND.getValue() == afterSales.getApplyType().intValue() && afterSales.getApplyReason().intValue() == 5));
    CoinDto coinDto = this.thirdService.produceCoin(order, orderAfterSalesList);
    receivedOrderCoinOver(order, coinDto);
    if (this.jedisClient.sismember("send_aftersales_market_msg_orderid_set", (String)order.getId()).booleanValue()) {
      logger.warn("sendToCoinProduce.sendMarketAftersalesOrderMsg order is alredly send msg, orderId#{}", order.getId());
      return false;
    } 
    Long aftersalesTime = order.getAftersalesTime();
    if (aftersalesTime != null && DateUtil.getCurrentMillis().longValue() >= aftersalesTime.longValue()) {
      Long curTime = Long.valueOf(System.currentTimeMillis());
      Order updateOrder = new Order();
      updateOrder.setId(order.getId());
      updateOrder.setMemberNo(order.getMemberNo());
      updateOrder.setFinishState(Integer.valueOf(OrderFinishStateEnum.FINISH.getValue()));
      updateOrder.setFinishTime(Long.valueOf(System.currentTimeMillis()));
      updateOrder.setUpdateTime(curTime);
      this.orderService.updateOrderFinish(updateOrder);
      OrderMqInfo orderMqInfo = new OrderMqInfo();
      orderMqInfo.setOrder_id((String)order.getId());
      orderMqInfo.setOrder_no(order.getOrderNo());
      orderMqInfo.setBusiness_type(String.valueOf(order.getBusinessType()));
      orderMqInfo.setMember_no(order.getMemberNo());
      orderMqInfo.setDistribution_flag(order.getDistributionFlag());
      orderMqInfo.setCreate_time(order.getCreateTime());
      orderMqInfo.setMember_id(order.getMemberId());
      this.aftersalesMessageSendUtil.sendOrderFinishMsg(orderMqInfo);
      this.jedisClient.sadd("send_aftersales_market_msg_orderid_set", new String[] { (String)order.getId() });
    } 
    return true;
  }
  
  private List<OrderAftersales> packageAfterSalesGoods(Long memberNo, AftersaleContext context) {
    List<OrderAftersales> orderAfterSalesList = context.getOrderAfterSalesList();
    orderAfterSalesList.forEach(orderAftersales -> {
          OrderAftersalesGoodsVO orderAftersalesGoodsVO = ((OrderAftersalesGoodsVO)(new OrderAftersalesGoodsVO()).setDeleteFlag(Integer.valueOf(BooleanEnum.NO.getValue()))).setBizId((String)orderAftersales.getId()).setMemberNo(memberNo);
          List<OrderAftersalesGoods> aftersalesGoods = this.orderAftersalesGoodsService.getList(orderAftersalesGoodsVO);
          orderAftersales.setOrderAftersalesGoodsList(aftersalesGoods);
        });
    return orderAfterSalesList;
  }
  
  public void sendToCoinProduce(Order order, BigDecimal payAmount, Integer coinType, String aftersalesNo) {
    String orderNo = order.getOrderNo();
    logger.info("sendToCoinProduce.init#orderNo#{}, ：coinService.produce businessType = {}, payAmount = {}, refundAmount = {}.", new Object[] { orderNo, order.getBusinessType(), payAmount });
    if (BigDecimal.ZERO.compareTo(payAmount) < 0 && OrderBusinessTypeEnum.BOX.getValue() != order.getBusinessType().intValue()) {
      logger.info("sendToCoinProduce#orderNo#{}, ：coinService.produce order = {}, payAmount = {}.", new Object[] { orderNo, JSON.toJSONString(order), payAmount });
      List<OrderGoods> orderGoodsList = order.getOrderGoodsList();
      BigDecimal orderGoodsTotalPayAmount = orderGoodsList.stream().filter(orderGoods -> (null != orderGoods.getPayAmount())).map(orderGoods -> orderGoods.getPayAmount()).reduce(BigDecimal.ZERO, BigDecimal::add);
      if (payAmount.compareTo(orderGoodsTotalPayAmount) == -1) {
        logger.info("sendToCoinProduce#orderNo#{}, ：coinService.produce orderGoodsTotalPayAmount = {}, payAmount = {}.", new Object[] { orderNo, orderGoodsTotalPayAmount, payAmount });
        reduceOrderGoodsPayAmount(orderGoodsList, orderGoodsTotalPayAmount.subtract(payAmount));
      } 
      CoinDto coinDto = this.thirdService.produce(order, payAmount, coinType, aftersalesNo);
      receivedOrderCoinOver(order, coinDto);
    } else {
      logger.info("sendToCoinProduce.only.return#orderNo#{}, ：no_coinService, orderBusinessType = {}, payAmount = {}.", new Object[] { orderNo, order.getBusinessType(), payAmount });
    } 
    if (this.jedisClient.sismember("send_aftersales_market_msg_orderid_set", (String)order.getId()).booleanValue()) {
      logger.warn("sendToCoinProduce.sendMarketAftersalesOrderMsg order is alredly send msg, orderId#{}", order.getId());
      return;
    } 
    Long aftersalesTime = order.getAftersalesTime();
    if (aftersalesTime != null && DateUtil.getCurrentMillis().longValue() >= aftersalesTime.longValue()) {
      Long curTime = Long.valueOf(System.currentTimeMillis());
      Order updateOrder = new Order();
      updateOrder.setId(order.getId());
      updateOrder.setMemberNo(order.getMemberNo());
      updateOrder.setFinishState(Integer.valueOf(OrderFinishStateEnum.FINISH.getValue()));
      updateOrder.setFinishTime(Long.valueOf(System.currentTimeMillis()));
      updateOrder.setUpdateTime(curTime);
      this.orderService.updateOrderFinish(updateOrder);
      OrderMqInfo orderMqInfo = new OrderMqInfo();
      orderMqInfo.setOrder_id((String)order.getId());
      orderMqInfo.setOrder_no(order.getOrderNo());
      orderMqInfo.setBusiness_type(String.valueOf(order.getBusinessType()));
      orderMqInfo.setMember_no(order.getMemberNo());
      orderMqInfo.setDistribution_flag(order.getDistributionFlag());
      orderMqInfo.setCreate_time(order.getCreateTime());
      orderMqInfo.setMember_id(order.getMemberId());
      this.aftersalesMessageSendUtil.sendOrderFinishMsg(orderMqInfo);
      this.jedisClient.sadd("send_aftersales_market_msg_orderid_set", new String[] { (String)order.getId() });
    } 
  }
  
  public void receivedOrderCoinOver(Order order, CoinDto coinDto) {
    if (coinDto == null)
      return; 
    BigDecimal refundYestaeCoin = BigDecimal.ZERO;
    Map<String, BigDecimal> productCoinMap = new HashMap<>();
    if (Objects.nonNull(coinDto)) {
      List<CoinChangeVo> coinChangeVos = coinDto.getCoinChangeVos();
      if (CollectionUtils.isNotEmpty(coinChangeVos)) {
        BigDecimal changeAmount = coinChangeVos.stream().map(o -> o.getChangeAmount()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, BigDecimal::add);
        refundYestaeCoin = refundYestaeCoin.add(changeAmount);
        productCoinMap = (Map<String, BigDecimal>)coinChangeVos.stream().collect(Collectors.toMap(CoinChangeVo::getId, CoinChangeVo::getChangeAmount));
      } 
    } 
    BigDecimal receiveCoinNum = (order.getReceiveCoinNum() == null) ? BigDecimal.ZERO : order.getReceiveCoinNum();
    logger.info("receivedOrderCoinOver订单实际返回受益卷#orderNo#{}, receiveCoinNum = {}, refundYestaeCoin = {}.", new Object[] { order.getOrderNo(), receiveCoinNum, refundYestaeCoin });
    order.setReceiveCoinNum(receiveCoinNum.add(refundYestaeCoin));
    order.setReceiveCoinState("1");
    order.setUpdateTime(DateUtil.getCurrentMillis());
    this.orderService.updateOrderSendCoins(order);
    List<OrderGoods> orderGoodsList = order.getOrderGoodsList();
    List<OrderGoods> updateOrderGoodsList = new ArrayList<>();
    for (OrderGoods orderGoods : orderGoodsList) {
      OrderGoods updateOrderGoods = new OrderGoods();
      updateOrderGoods.setId(orderGoods.getId());
      BigDecimal coinAmount = (productCoinMap.get(orderGoods.getProductId()) != null) ? productCoinMap.get(orderGoods.getProductId()) : BigDecimal.ZERO;
      updateOrderGoods.setReceiveCoinNum(coinAmount);
      updateOrderGoods.setUpdateTime(DateUtil.getCurrentMillis());
      updateOrderGoods.setMemberNo(order.getMemberNo());
      updateOrderGoodsList.add(updateOrderGoods);
    } 
    this.orderGoodsService.updateOrderGoodsSendCoinsInfo(updateOrderGoodsList);
  }
  
  private void reduceOrderGoodsPayAmount(List<OrderGoods> orderGoodsList, BigDecimal reduce) {
    orderGoodsList.stream().sorted((o1, o2) -> o2.getPayAmount().compareTo(o1.getPayAmount()));
    for (OrderGoods orderGoods : orderGoodsList) {
      if (reduce.compareTo(BigDecimal.ZERO) != 1)
        break; 
      if (orderGoods.getPayAmount().compareTo(reduce) == 1) {
        orderGoods.setPayAmount(orderGoods.getPayAmount().subtract(reduce));
        break;
      } 
      reduce = reduce.subtract(orderGoods.getPayAmount());
      orderGoods.setPayAmount(BigDecimal.ZERO);
    } 
  }
  
  private CoinHandlerAmount coinHandlerByAfterSale(Order order, List<OrderAftersales> afterSalesList) {
    try (AftersaleContext context = AftersaleContext.createContext()) {
      Long memberNo = order.getMemberNo();
      String orderId = (String)order.getId();
      String orderNo = order.getOrderNo();
      List<OrderAftersales> unCompleteOrderAfterSalesWithoutReject = this.orderAftersalesService.getUnCompleteOrderAfterSalesWithoutReject(orderId, memberNo);
      boolean afterSalesIsDone = CollectionUtils.isEmpty(unCompleteOrderAfterSalesWithoutReject);
      if (!afterSalesIsDone) {
        logger.info("订单号有未完结的售后单：orderId = {},orderNo = {}", orderId, orderNo);
        return null;
      } 
      CoinHandlerAmount coinHandlerAmount = new CoinHandlerAmount();
      List<OrderRefund> orderRefundList = context.getOrderRefundList();
      List<String> returnPostFeeAfterSaleIds = (List<String>)afterSalesList.stream().filter(afterSales -> (OrderAftersalesTypeEnum.ONLY_REFUND.getValue() == afterSales.getApplyType().intValue())).map(TeaBaseEntity::getId).distinct().collect(Collectors.toList());
      orderRefundList.removeIf(orderRefund -> returnPostFeeAfterSaleIds.contains(orderRefund.getAftersalesId()));
      BigDecimal allRefundAmount = YestaeCoinUtils.computerAllRefundAmount(orderRefundList);
      coinHandlerAmount.setPayAmount(order.getPayAmount().subtract(order.getDeliveryCost()).subtract(allRefundAmount));
      logger.info("OrderYiyuanbiListener.coinHandlerByAfterSale.refundAmount.orderNo#{}, allRefundAmount= {}.", order
          .getOrderNo(), allRefundAmount);
      List<OrderAftersales> needCoumputerAftersales = (List<OrderAftersales>)afterSalesList.stream().filter(afterSales -> (OrderAftersalesTypeEnum.RETURN_GOODS_AND_REFUND.getValue() == afterSales.getApplyType().intValue() && OrderApprovalApprovalStatusEnum.APPROVAL_OK.getValue() == afterSales.getCheckState().intValue())).collect(Collectors.toList());
      coinHandlerAmount.getOrderAftersalesList().addAll(needCoumputerAftersales);
      coinHandlerAmount.setRefundYestaeCoin(YestaeCoinUtils.computerRefundYestaeCoin(orderRefundList, needCoumputerAftersales));
      return coinHandlerAmount;
    } 
  }
}
